/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* global mobileRepServices */

diaryServices.factory('AuthInterceptor', function ($q, $injector, Configuration,$log) {
    var inFlightAuthRequest = null;
    return {
        request: function (config) {
            config.headers = config.headers || {};
            config.headers.Authorization = 'Bearer ' + Configuration.getConfiguration().jsonwebtoken;
            return config;
        },
        responseError: function (response) {
            console.log("response ");
            console.log(response);
            switch (response.status) {
                case 401:
                    var deferred = $q.defer();
                    if (!inFlightAuthRequest) {
                        var credentials = {};
                        
                        credentials.username = sessionStorage.email;
                        credentials.password = sessionStorage.password;
                        
                        inflightAuthRequest = $injector.get("$http").post(Configuration.getConfiguration().authenticationPostURL, credentials);
                    }

                    inflightAuthRequest.then(function (r) {
                        inflightAuthRequest = null;
                        
                        if( r.status === 200){
                            $log.info()
                            Configuration.getConfiguration().jsonwebtoken = r.data.jwtToken;
                            Configuration.getConfiguration().operatorId = r.data.operatorId;
                            Configuration.getConfiguration().operatorName = r.data.operatorName;
                            Configuration.saveLoginConfiguration();
                            
                            $injector.get("$http")(response.config).then(function (resp) {
                                deferred.resolve(resp);
                            }, function (resp) {
                                resp.status = 403; // Forbidden 
                                deferred.reject(resp);
                                
                            });
                        }else{
                             response.status = 403; // Forbidden 
                             deferred.reject(response); 
                            
                        };
                        
                    }, function (error) {
                        
                        console.log('Authentication Failed writing original response to 403 Forbidden');
                        response.status = 403; // Forbidden 
                        inflightAuthRequest = null;
                        deferred.reject(response);
                        return;
                    });
                    return deferred.promise;
                    break;
                    
                case 0: // we can get status 0 we will treat as a timeout
                    var deferred = $q.defer();
                        console.log('Http Request Timed Out');
                        response.status = 408; // Forbidden 
                        inflightAuthRequest = null;
                        deferred.reject(response);
                    
                    return deferred.promise;
                    break;
                default:
                    break;
            }
            return response || $q.when(response);
        }
    };
});

diaryServices.factory('TestAuthentication',function($q,$http,Configuration,$log){
    
    
    var test = function(){
        var loginPromise = $q.defer();
        
        $log.info("Test Authentication");
        Configuration.getConfiguration().jsonwebtoken = ""; //force authentication failure
        
        $http.get( "http://localhost:9090/BusinessLogicServices/api/action/actiontype/webdiary/getall").then(function(data){
            //$log.info( r.data );
            loginPromise.resolve( data ); // return token
        },
        function(error){
            $log.error( error );
            loginPromise.resolve( "" ); // on error return empty token
        });
        
        return loginPromise.promise;
    };
    
    
    return{
        test: test
    };
});
