/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

diaryServices.factory('ActionDefinitions', function () {
    
    var definitions = {};
    //Action Types
    definitions.type = {};
    definitions.type.inTransit = 2000;
    definitions.type.clone = 2001;
    definitions.type.breakdown = 2002;
    definitions.type.productChanged = 2003;
    definitions.type.productQtyChanged = 2004;
    definitions.type.collection = 2005;
    
    definitions.type.requestTypeLogDelivery = 2006;
    definitions.type.requestTypeLogCollection = 2007;
    definitions.type.requestTypeLogOrder = 2008;
    definitions.type.requestTypeLogBreakdown = 2009;
    definitions.type.requestTypeLogChangeover = 2010;
    definitions.type.requestTypeLogOther = 2011;
    definitions.type.assignEquipment = 2012;    
    
    
    definitions.type.requestAccepted = 2020;
    definitions.type.requestRejected = 2021;
    definitions.type.requestApproved = 2022;
    definitions.type.requestIssuedPurchaseOrder = 2023;
    definitions.type.requestApprovedPurchaseOrder = 2024;
    
    
    definitions.type.requestCanceled = 2052;
    definitions.type.requestComplete=2025;
    definitions.type.driverChanged=2013;
    definitions.type.verifyCollection=2015;
    
    // These actions change the request status , and are internally used only.
    
//    definitions.type.requestUnsyncronized = 91000;
//    definitions.type.requestUnAssigned = 91001;
//    definitions.type.requestAccepted = 91002;
//    definitions.type.requestCanceled = 91003;
//    definitions.type.requestAwaitingApproval = 91004;
//    definitions.type.requestAwaitingPurchaseOrder = 91005;
//    definitions.type.requestIssuedPurchaseOrder = 91006;
//    definitions.type.requestApprovedPurchaseOrder = 91007;
//    definitions.type.requestApproved = 91008;
//    definitions.type.requestCompleted = 91009;
    definitions.type.requestInWarehouse = 91010;

    
    
    
    
    //Action Priorities
    definitions.priority = {};
    definitions.priority.low = 1;
    definitions.priority.medium = 2;
    definitions.priority.high = 3;
    definitions.priority.urgent = 4; 

    var get = function(){
      return definitions;  
    };

    return{
       get: get  
    };
});


diaryServices.factory('EquipmentTypeDefinitions', function () {
    
    var definitions = {};
    
    definitions.type = {};
    definitions.type.SINGLE = 1;
    definitions.type.EQUIPMENTTYPE = 4;
    definitions.type.MULTIPLE = 2;
    definitions.type.PRODUCT =5;
    definitions.type.PRODUCTTYPE = 6;


    var get = function(){
      return definitions;  
    };

    return{
       get: get  
    };
});


diaryServices.factory('PlantStatusDefinitions', function () {
    
    var definitions = {};
    
    definitions.type = {};
    definitions.type.AVAILABLE = {id: 1, description: 'Available'};
    definitions.type.ONHIRE = {id: 2, description: 'On hire'};
    definitions.type.INREPAIR = {id: 3, description: 'In Repair'};
    definitions.type.COLLECTION = {id: 4, description: 'Collection'};
    definitions.type.BROKENDOWN = {id: 5, description: 'Broken Down'};
    definitions.type.UNAVAILABLE = {id: 6, description: 'Unavailable'};
    definitions.type.SOLD = {id: 7, description: 'Sold'};
    definitions.type.INTRANSFER = {id: 8, description: 'In Transfer'};
    definitions.type.MIDDISPOSAL = {id: 9, description: 'Mid Disposal'};
    definitions.type.PLANTCODECHANGE = {id: 10, description: 'Plant Code Changed'};
    definitions.type.NOTREADYFORHIRE = {id: 11, description: 'Not Ready For Hire'};
    definitions.type.OVERBOOKED = {id: 20, description: 'Overbooked'};

    var get = function(){
      return definitions;  
    };

    return{
       get: get  
    };
});



diaryServices.factory('ClientConfigDefinitions', function () {
    
    var definitions = {};
    
    definitions.DEFAULT = 0;
    definitions.PPS = 2;
    definitions.JEMSER = 3;
    definitions.COFFEY = 4;
    definitions.GHGROUP = 5;
    
    
    var get = function(){
      return definitions;  
    };

    return{
       get: get  
    };
});

diaryServices.factory('RequestStatusDefinitions', function () {
    var definitions = {};
    definitions.UNSYNCRONIZED = {};
    definitions.UNSYNCRONIZED.id = 1000;
    definitions.UNSYNCRONIZED.description = "UnSyncronized";
    definitions.UNSYNCRONIZED.actionId = 91000;
    
    definitions.UNASSIGNED = {};
    definitions.UNASSIGNED.id = 1001;
    definitions.UNASSIGNED.description = "UnAssigned";
    definitions.UNASSIGNED.actionId = 91001;
    
    definitions.ACCEPTED = {};
    definitions.ACCEPTED.id = 1002;
    definitions.ACCEPTED.description = "Accepted";
    definitions.ACCEPTED.actionId = 91002;
    
    definitions.REJECTED = {};
    definitions.REJECTED.id = 1003;
    definitions.REJECTED.description = "Rejected";
    definitions.REJECTED.actionId = 91003;
    
    definitions.CANCELLED = {};
    definitions.CANCELLED.id = 1003;
    definitions.CANCELLED.description = "Rejected";
    definitions.CANCELLED.actionId = 91003;
    
    definitions.AWAITINGAPPROVAL = {};
    definitions.AWAITINGAPPROVAL.id = 1004;
    definitions.AWAITINGAPPROVAL.description = "Awaiting Approval";
    definitions.AWAITINGAPPROVAL.actionId = 91004;
    
    definitions.AWAITINGPURCHASEORDER = {};
    definitions.AWAITINGPURCHASEORDER.id = 1005;
    definitions.AWAITINGPURCHASEORDER.description = "Awaiting Purchase Order";
    definitions.AWAITINGPURCHASEORDER.actionId = 91005;
    
    definitions.ISSUEDPURCHASEORDER = {};
    definitions.ISSUEDPURCHASEORDER.id = 1006;
    definitions.ISSUEDPURCHASEORDER.description = "Issued Purchase Order";
    definitions.ISSUEDPURCHASEORDER.actionId = 91006;
    
    definitions.APPROVEDPURCHASEORDER = {};
    definitions.APPROVEDPURCHASEORDER.id = 1007;
    definitions.APPROVEDPURCHASEORDER.description = "Approved Purchase Order";
    definitions.APPROVEDPURCHASEORDER.actionId = 91007;
    
    definitions.APPROVED = {};
    definitions.APPROVED.id = 1008;
    definitions.APPROVED.description = "Approved";
    definitions.APPROVED.actionId = 91008;
    
    definitions.COMPLETED = {};
    definitions.COMPLETED.id = 1009;
    definitions.COMPLETED.description = "Completed";
    definitions.COMPLETED.actionId = 91009;
    
    definitions.INWAREHOUSE = {};
    definitions.INWAREHOUSE.id = 1010;
    definitions.INWAREHOUSE.description = "In Warehouse";
    definitions.INWAREHOUSE.actionId = 91010;
    
    
    
    
    
    var get = function(){
      return definitions;  
    };
    return{
       get: get  
    };
});

diaryServices.factory('RequestTypeDefinitions', function () {
    var definitions = {};
    definitions.DELIVERY = {};
    definitions.DELIVERY.id = 2000;
    definitions.DELIVERY.description = "Delivery";
    
    
    definitions.COLLECTION = {};
    definitions.COLLECTION.id = 2001;
    definitions.COLLECTION.description = "Collection";
    
    definitions.ORDER = {};
    definitions.ORDER.id = 2002;
    definitions.ORDER.description = "Order";
    
    definitions.BREAKDOWN = {};
    definitions.BREAKDOWN.id = 2003;
    definitions.BREAKDOWN.description = "Breakdown";
    
    definitions.CHANGEOVER = {};
    definitions.CHANGEOVER.id = 2004;
    definitions.CHANGEOVER.description = "Changeover";
    
    definitions.OTHER = {};
    definitions.OTHER.id = 2005;
    definitions.OTHER.description = "Other";
    
    definitions.ENQUIRY = {};
    definitions.ENQUIRY.id = 2006;
    definitions.ENQUIRY.description = "Enquiry";
    
    definitions.RETURN = {};
    definitions.RETURN.id = 2007;
    definitions.RETURN.description = "Return";
    
    
    definitions.ALL = {};
    definitions.ALL.id = -1;
    definitions.ALL.description = "All"
    
    
    definitions.ASSIGNED = {};
    definitions.ASSIGNED.id = -2;
    definitions.ASSIGNED.description = "Assigned"
    
    definitions.COMPLETE = {};
    definitions.COMPLETE.id = -3;
    definitions.COMPLETE.description = "Complete"
    
    
    
    var get = function(){
      return definitions;  
    };
    return{
       get: get  
    };
});

diaryServices.factory('ContactDetailCategories', function () {
    var definitions = {};
    definitions.MAINPHONE = {};
    definitions.MAINPHONE.id = 1001;
    definitions.MAINPHONE.description = "Main Phone";
    
    
    definitions.MOBILE = {};
    definitions.MOBILE.id = 1002;
    definitions.MOBILE.description = "Mobile";
    
    definitions.EMAIL = {};
    definitions.EMAIL.id = 1000;
    definitions.EMAIL.description = "Email";
    
    definitions.FAX = {};
    definitions.FAX.id = 1003;
    definitions.FAX.description = "Fax";
    
    
    
    
    var get = function(){
      return definitions;  
    };
    return{
       get: get  
    };
});
