/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
diaryControllers.controller('HireHomeCtrl', function ($scope, $state,ClientConfig, HomeService,ConfirmModalService, $q, ActionFactory, ActionDefinitions, RequestStatusDefinitions, uiGridConstants, $uibModal, RequestTypeDefinitions) {

        $scope.diaryUrl = ClientConfig.route('templates/hirehome/hireHome.html');

        $scope.forcasts = [{type:'All Dates', value: 'All'},{type: '3 day forecast', value: 3},{type:'5 day forecast', value:5},{type:'7 day forecast',value:7},{type:'future dates', value:0},{type:'past dates',value: -1}];
        $scope.selectedForcast = $scope.forcasts[0];
        $scope.notPrimary = angular.fromJson(sessionStorage.notPrimary);
        $scope.isEditing = false;
        $scope.packageSeqNumber = 1;
        $scope.nextLineNumber = 1;
        
        $scope.filteredDates = function(){
                var requests = angular.copy($scope.requests);
                var currentDateTime = new Date();
                $scope.filteredRequests = [];
                requests.forEach(function(request){
                        if($scope.checkParams((new Date(request.requiredDate) - currentDateTime)))
                                $scope.filteredRequests.push(request);
                });
                console.log("all requests");
                console.log($scope.filteredRequests);
                $scope.home_grid_options.data = $scope.filteredRequests;
        };
        
        $scope.checkParams = function(dateDifference){
                if($scope.selectedForcast.values.value === 'All')
                        return true;
                else if($scope.selectedForcast.values.value === 0 && dateDifference > 0)
                        return true;
                else if($scope.selectedForcast.values.value === -1 && dateDifference < 0)
                        return true;
                else if(dateDifference > 0 && dateDifference < $scope.selectedForcast.values.value)
                        return true;
                else
                        return false;
        };
        
        $scope.isCategorySelected = function (rowEntity) {
                if ($scope.selectedRequest == null)
                        return false;
                return  $scope.selectedRequest.id === rowEntity.id;
        };

        $scope.goToActions = function () {
                console.log("going to actions");
                $state.go('base.actionsscreen');
        };

        $scope.goToWarehouse = function () {
                console.log("going to warehouse");
                $state.go('base.warehousescreen');
        };

        $scope.verifyDocument = function (request) {

                if (request === null || request === undefined)
                        return false;
                $scope.header = "Contract";
                var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'templates/jemserinternal/modals/verifydocumentmodal.html',
                        controller: 'VerifyDocumentModalCtrl',
                        backdrop: 'static',
                        //size: 'lg',
                        windowClass: 'request-modal-window',
                        scope: $scope
                });

                modalInstance.result.then(function () {
                        console.info('OK: Modal dismissed at: ' + new Date());
                        return true;
                }, function () {
                        console.info('CANCEL: Modal dismissed at: ' + new Date());
                        return false;
                });

        };

        $scope.newRequest = function (edit) {
                if( edit !== true){
                    $scope.selectedRequest = null;
                }
                console.log("this is edit");
                console.log(edit);
                $scope.isEditing = edit;
                if (edit === null || edit === undefined || edit !== true) {
                        $scope.isEditing = false;
                        console.log("making a new request");
                        $scope.selected = HomeService.buildRequestBean();
                } else {

                        //Initialising it to old Webdiary format for the screen to render it
                console.log("editing request");
                console.log($scope.selected);
                console.log($scope.selectedRequest);
                        $scope.selected = $scope.selectedRequest;
                        $scope.jemserProducts = [];
                        angular.forEach($scope.selected.requestToJemserProductMapBeans, function (key, value) {
                                $scope.jemserProducts.push(key);
                                if(key.lineNumber !== null && $scope.nextLineNumber < key.lineNumber){
                                        $scope.nextLineNumber = key.lineNumber;
                                }
                                if(key.packageSeqNumber !== null && $scope.packageSeqNumber < key.packageSeqNumber){
                                        $scope.packageSeqNumber = key.packageSeqNumber;
                                }
                        });

                }

                if (angular.fromJson(localStorage.jemserInternal != true)) {

                        //using the same modal for both edit and create just want to have a title passed in
                        //$scope.title = title
                        var modalInstance = $uibModal.open({
                                animation: $scope.animationsEnabled,
                                templateUrl: 'templates/request/requestmodal.html',
                                controller: 'RequestCtrl',
                                backdrop: 'static',
                                size: 'lg',
                                scope: $scope
                        });

                        modalInstance.result.then(function () {
                                console.info('Modal dismissed at: ' + new Date());
                                $scope.load();
                        }, function () {
                                console.info('Modal dismissed at: ' + new Date());
                        });

                } else {
                        console.log("opening internal request");
                        $scope.editable = true;
                        //$scope.title = title;
                        var modalInstance = $uibModal.open({
                                animation: $scope.animationsEnabled,
                                templateUrl: 'templates/jemserinternal/modals/neweditrequestmodal.html',
                                controller: 'LegacyNewEditRequestCtrl',
                                windowClass: 'request-modal-window',
                                backdrop: 'static',
                                scope: $scope
                        });

                        modalInstance.result.then(function () {
                                console.info('Modal dismissed at: ' + new Date());
                                $scope.load();
                        }, function () {
                                console.info('Modal dismissed at: ' + new Date());
                        });

                }

        };
        
        $scope.requestStatus = function () {
        return RequestStatusDefinitions.get();
    };
        
        $scope.requestStatusChange = function (item, requestStatus) {
        console.log(item);

        var modalOptions = {
            closeButtonText: 'Cancel',
            actionButtonText: 'Ok',
            headerText: 'Mark Request ' + requestStatus.description + ' ?',
            bodyText: 'Are you sure you want to change the status of this request to  ' + requestStatus.description + '?'
        };

        ConfirmModalService.showModal({}, modalOptions)
                .then(function (result) {
                    // your-custom-logic
                    if (result) {
                            
                            
                        var requestStatusChangeAction = HomeService.buildAction(item, requestStatus.actionId, true);
                        if(item.requestType.id === 2001){
                             HomeService.reverseOffHire(item.id);   
                        }
                            HomeService.createAction(requestStatusChangeAction).then(function (data) {
                            $scope.load();
                            console.log("$scope.selectedRequest = ");
                            console.log($scope.selectedRequest);



                        });
                    }
                });

    };

        $scope.splitDelivery = function(){
        $scope.splitDeliveryUrl = ClientConfig.route('templates/jemserinternal/modals/splitdeliverymodal.html');
                
                console.log("editing request");
                console.log($scope.selected);
                console.log($scope.selectedRequest);
                        $scope.selected = $scope.selectedRequest;
                        $scope.jemserProducts = [];
                        $scope.newProducts = [];
                        angular.forEach($scope.selected.requestToJemserProductMapBeans, function (key, value) {
                                console.log("this is the equipment");
                                console.log(key);
                                
                               // $scope.jemserProducts.push(key);
                                if(key.lineNumber !== null && $scope.nextLineNumber < key.lineNumber){
                                        $scope.nextLineNumber = key.lineNumber;
                                }
                                if(key.packageSeqNumber !== null && $scope.packageSeqNumber < key.packageSeqNumber){
                                        $scope.packageSeqNumber = key.packageSeqNumber;
                                }
                                if(key.jemserProductId.productClassBean.id === 2){
                                    $scope.jemserProducts.push(key);   
                                }
                        });
                        
                        $scope.selected.requestToJemserProductMapBeans = $scope.newProducts;
                        console.log("opening internal split delivery");
                        $scope.editable = true;
                        //$scope.title = title;
                        var modalInstance = $uibModal.open({
                                animation: $scope.animationsEnabled,
                                templateUrl: $scope.splitDeliveryUrl,
                                controller: 'splitDeliveryController',
                                windowClass: 'request-modal-window',
                                backdrop: 'static',
                                scope: $scope
                        });

                        modalInstance.result.then(function () {
                                console.info('Modal dismissed at: ' + new Date());
                                $scope.load();
                        }, function () {
                                console.info('Modal dismissed at: ' + new Date());
                        });
               
        }

        $scope.home_grid_options = {
                enableHorizontalScrollbar: 0,
                enableVerticalScrollbar: 0,
                onRegisterApi: function (gridApi) {
                        $scope.gridApi = gridApi;
                },
                showColumnFooter: true,
                rowTemplate: 'templates/hirehome/rows/requestrow.html'
        };



        $scope.home_grid_options.columnDefs = [
                {field: 'id', name: 'ID', type: 'number', width: 50, sort: {
                                direction: uiGridConstants.ASC,
                                priority: 0
                        }},
                {field: 'requestType.description', name: 'Type', width: 80},
                {field: 'lastRequestToJemserDocumentNo',name: 'Doc No'},
                {field: 'businessEntityBean.name', name: 'organisation'},
                {field: 'jemserProjectBean.description', name: 'Project'},
                {field: 'address.name', name: 'Location'},
                {field: 'jemserProductBean.description', name: 'Equipment'},
                {field: 'requiredDate', name: 'date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'},
                {field: 'requestStatus.description', name: 'status', width: 90},
                {field: 'responderBusinessEntityBean.name', name: 'hire_co', footerCellTemplate: "<div style='float:right;'><button style='background-color:transparent; border-color:transparent;' ng-click='grid.appScope.newRequest()'>New Request <i class='glyphicon glyphicon-plus'></i></button></div>"},
                {field: 'driver.name', name: 'Driver', width: 80}
        ];
        
        if($scope.notPrimary === false || $scope.notPrimary === null || $scope.notPrimary === undefined){
                 $scope.home_grid_options.columnDefs.push({field: 'responderBusinessEntityBean.name', name: 'hire_co', footerCellTemplate: "<div style='float:right;'><button style='background-color:transparent; border-color:transparent;' ng-click='grid.appScope.newRequest()'>New Request <i class='glyphicon glyphicon-plus'></i></button></div>"})       
                }
                else{
                 $scope.home_grid_options.columnDefs.push({field: 'responderBusinessEntityBean.name', name: 'hire_co'})       

                }


        HomeService.getEmployees().then(function (employees) {
//            console.log("this is the employees")
//            console.log(employees.data);
                $scope.employees = employees.data;
        });



        $scope.load = function () {

                var getPromise = $q.defer();

                HomeService.getRequests($scope.filterSelected).then(function (data) {

                        $scope.requests = data;
//            console.log("this is the data");
//            console.log($scope.requests);
                        if ($scope.filterSelected.requestTypeId[0] != 0) {
                                $scope.newRequests = HomeService.removeRowsWithDrivers($scope.requests);
                                $scope.requests = $scope.newRequests;

                                if (angular.fromJson(localStorage.jemserInternal) === 1) {
//                            console.log("looping through requests");
                                        angular.forEach($scope.requests, function (key, val) {
//                                console.log(key);
//                                console.log(key.requestToJemserProductMapBeans.length);
                                                if (key.requestToJemserProductMapBeans.length > 0) {
                                                        key.jemserProductBean = key.requestToJemserProductMapBeans[0].jemserProductId;
                                                }
                                                
                                                // handle getting last request to document map value
                                                console.log("Key =");
                                                console.log(key);
                                                if ( key.requestToDocumentMapBeans.length > 0 ){
                                                    
                                                    
                                                    key.lastRequestToJemserDocumentNo = key.requestToDocumentMapBeans[ key.requestToDocumentMapBeans.length - 1].documentNumber;
                                                    // if its a quote stick a Q in front
                                                    if( key.requestToDocumentMapBeans[ key.requestToDocumentMapBeans.length - 1].mappingDocumentTypeId === 5 ) // a Quotation
                                                       key.lastRequestToJemserDocumentNo = 'Q - ' + key.lastRequestToJemserDocumentNo;
                                                    
                                                }else{
                                                    key.lastRequestJemserDocumentNo = null;
                                                };
                                        });

                                }
                        }else {
                            // all tabl will exclude completed jobs
                            if (angular.fromJson(localStorage.jemserInternal) === 1 && $scope.filterSelected.completeOnly != null && $scope.filterSelected.completeOnly != true ) {

                                        angular.forEach($scope.requests, function (value, index) {
                                                
                                                if ( value.requestStatus.id === RequestStatusDefinitions.get().COMPLETED.id ) {
                                                    console.log(" spliced " + index );
                                                    delete $scope.requests[ index ];
                                                    //$scope.requests.splice(index, 1);   
                                                }else{
                                                
                                                    console.log("Value =");
                                                    console.log(value);
                                                    if ( value.requestToDocumentMapBeans.length > 0 ){


                                                        value.lastRequestToJemserDocumentNo = value.requestToDocumentMapBeans[ value.requestToDocumentMapBeans.length - 1].documentNumber;
                                                        // if its a quote stick a Q in front
                                                        if( value.requestToDocumentMapBeans[ value.requestToDocumentMapBeans.length - 1].mappingDocumentTypeId === 5 ) // a Quotation
                                                           value.lastRequestToJemserDocumentNo = 'Q - ' + value.lastRequestToJemserDocumentNo;

                                                    }else{
                                                        value.lastRequestJemserDocumentNo = null;
                                                    };
                                                };
                                        });

                            }else{
                                angular.forEach($scope.requests, function (value, index) {
                                                    console.log("Value =");
                                                    console.log(value);
                                                    if ( value.requestToDocumentMapBeans.length > 0 ){


                                                        value.lastRequestToJemserDocumentNo = value.requestToDocumentMapBeans[ value.requestToDocumentMapBeans.length - 1].documentNumber;
                                                        // if its a quote stick a Q in front
                                                        if( value.requestToDocumentMapBeans[ value.requestToDocumentMapBeans.length - 1].mappingDocumentTypeId === 5 ) // a Quotation
                                                           value.lastRequestToJemserDocumentNo = 'Q - ' + value.lastRequestToJemserDocumentNo;

                                                    }else{
                                                        value.lastRequestJemserDocumentNo = null;
                                                    };
                                               
                                        });
                            };
                            
                        }
                        console.log("all requests");
                        console.log($scope.requests);
                        $scope.home_grid_options.data = $scope.requests;

                        if ( $scope.currentFilter === "UnCompleted"){
                            for (var i = 0; i < $scope.requests.length; i++) {
                                if($scope.requests[i].lastRequestToJemserDocumentNo !== null && typeof $scope.requests[i].lastRequestToJemserDocumentNo !== 'undefined' ){
                                    delete $scope.requests[i];
                                }
                            };
                        };



                        $scope.loadingRequestSpinner = "";
                        $scope.loadingRequestSpinner1 = "";
                        $scope.loadingRequestSpinner2 = "";
                        $scope.loadingRequestSpinner3 = "";
                        $scope.loadingRequestSpinner4 = "";
                        $scope.loadingRequestSpinner5 = "";
                        $scope.loadingRequestSpinner6 = "";
                        $scope.loadingRequestSpinner7 = "";
                        $scope.loadingRequestSpinner8 = "";
                        $scope.loadingRequestSpinner9 = "";
                        $scope.loadingRequestSpinner10 = "";
                        $scope.loadingRequestSpinner11 = "";
                        
                        getPromise.resolve(true);
                });
                return getPromise.promise;
        }


        $scope.handleLoad = function (type) {

                $scope.filterSelected.completeOnly = false;

//        console.log(type);

                switch (type) {
                        case 1:
                                $scope.currentFilter = "Delivery";
                                $scope.filterSelected.requestTypeId = [2000];
                                $scope.filterSelected.assigned = false;
                                $scope.loadingRequestSpinner1 = "glyphicon glyphicon-refresh spinning";
                                break;
                        case 2:
                                $scope.currentFilter = "Collections";
                                $scope.filterSelected.requestTypeId = [2001];
                                $scope.filterSelected.assigned = false;
                                $scope.loadingRequestSpinner2 = "glyphicon glyphicon-refresh spinning";

                                break;
                        case 3:
                                $scope.currentFilter = "Collections";
                                $scope.filterSelected.requestTypeId = [1002];
                                $scope.filterSelected.assigned = false;
                                $scope.loadingRequestSpinner3 = "glyphicon glyphicon-refresh spinning";
                                $scope.currentRequestType.description = "On Hold";
                                $scope.buttonBackground = ClientConfig.requestStyle(RequestTypeDefinitions.get().HOLD.id);
                                break;
                        case 4:
                                $scope.currentFilter = "All";
                                $scope.filterSelected.requestTypeId = [0];
                                $scope.filterSelected.assigned = false;
                                $scope.loadingRequestSpinner4 = "glyphicon glyphicon-refresh spinning";

                                break;
                        case 5:
                                $scope.currentFilter = "Breakdown";
                                $scope.filterSelected.requestTypeId = [2003];
                                $scope.filterSelected.assigned = false;
                                $scope.loadingRequestSpinner5 = "glyphicon glyphicon-refresh spinning";

                                break;

                        case 6:
                                $scope.currentFilter = "Assigned";
                                $scope.filterSelected.requestTypeId = [0];
                                $scope.filterSelected.assigned = true;
                                $scope.loadingRequestSpinner6 = "glyphicon glyphicon-refresh spinning";
                                $scope.currentRequestType.description = "Assigned";
                                $scope.buttonBackground = ClientConfig.requestStyle(RequestTypeDefinitions.get().ASSIGNED.id);
                                break;

                        case 7:
                                $scope.currentFilter = "Collections";
                                $scope.filterSelected.requestTypeId = [1005];
                                $scope.filterSelected.assigned = false;
                                $scope.loadingRequestSpinner7 = "glyphicon glyphicon-refresh spinning";
                                $scope.currentRequestType.description = "Other";
                                $scope.buttonBackground = ClientConfig.requestStyle(RequestTypeDefinitions.get().OTHER.id);
                                break;

                        case 8:
                                $scope.currentFilter = "Completed";
                                $scope.filterSelected.requestTypeId = [0];
                                $scope.filterSelected.assigned = false;
                                $scope.filterSelected.completeOnly = true;
                                $scope.loadingRequestSpinner8 = "glyphicon glyphicon-refresh spinning";


                                break;
                        case 9:
                                $scope.currentFilter = "Enquiries";
                                $scope.filterSelected.requestTypeId = [2006];
                                $scope.filterSelected.assigned = false;
                                $scope.loadingRequestSpinner9 = "glyphicon glyphicon-refresh spinning";

                                break;
                        case 10:
                                $scope.currentFilter = "Returns";
                                $scope.filterSelected.requestTypeId = [2007];
                                $scope.filterSelected.assigned = false;
                                $scope.loadingRequestSpinner10 = "glyphicon glyphicon-refresh spinning";

                                break;
                        case 11:
                                $scope.currentFilter = "UnCompleted";
                                $scope.filterSelected.requestTypeId = [0];
                                $scope.filterSelected.assigned = false;
                                $scope.filterSelected.completeOnly = true;
                                $scope.loadingRequestSpinner11 = "glyphicon glyphicon-refresh spinning";


                                break;       
                }
                $scope.load();
        }

        // var getRequestTimer = setInterval($scope.getRequests, 4000);
        $scope.filterSelected = {};
        $scope.jemserInternal = angular.fromJson(localStorage.jemserInternal);
        HomeService.getProfile().then(function (data) {
//            console.log("the profile is");
//            console.log(data);
                $('#navUser').text(sessionStorage.email);
                $('#companyName').text(sessionStorage.companyName);
                if (data.data.businessEntityProfileBeans.length === 1) {
                        $scope.myCompany = data.data.businessEntityProfileBeans[0];
                        $scope.companyId = data.data.businessEntityProfileBeans[0].id;
                        sessionStorage.companyId = data.data.businessEntityProfileBeans[0].id;
                        $scope.companyName = data.data.businessEntityProfileBeans[0].name;
                        sessionStorage.companyName = $scope.companyName;
//                console.log("the company is");
//                console.log($scope.companyId);

                        //$scope.currentMarker = data.data.businessEntityProfileBeans[0].address;
                        $scope.filterSelected = HomeService.buildSearchBean();
                        HomeService.getEmployees().then(function (employees) {
//            console.log("this is the employees")
//            console.log(employees.data);
                                $scope.employees = employees.data;
                        });
                        $scope.handleLoad(9);
                } else {
                        $scope.companyId = data.data.businessEntityProfileBeans[0].id;
                        sessionStorage.companyId = data.data.businessEntityProfileBeans[0].id;
                        //$scope.currentMarker = data.data.businessEntityProfileBeans[0].address;
                        $scope.filterSelected = HomeService.buildSearchBean();
                        HomeService.getEmployees().then(function (employees) {
                                console.log("this is the employees")
                                console.log(employees.data);
                                $scope.employees = employees.data;
                        });
                        $scope.handleLoad(9);
                }



        });

        if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(function (position) {
                        $scope.$apply(function () {
                                $scope.currentMarker = {};
                                $scope.currentMarker.lng = position.coords.longitude;
                                $scope.currentMarker.lat = position.coords.latitude;
                                console.log($scope.currentMarker);
                        });
                });

        } else {
                console.log("Geolocation is not supported by this browser.");
        }

        $scope.sendToWarehouse = function (item) {
                // First Create Request Status Change Action ( In Warehouse ) this will update the status on the request to In Warehouse.
                var requestStatus = RequestStatusDefinitions.get().INWAREHOUSE.id;
                $scope.createAction(item, ActionDefinitions.get().type.requestInWarehouse,true).then(function(data){
                        $scope.load();
                });
                $scope.load();
        };


        $scope.actionDefinitions = ActionDefinitions.get();
        console.log("the searchBean is");
        console.log($scope.filterSelected);




        /* if ($scope.selectedRequest == null){
         return false;
         return  $scope.selectedRequest.id === rowEntity.id;
         };*/





        $scope.getRequestStatusColor = function (rowEntity) {
                var color = '';

                // console.log(rowEntity)
                if (rowEntity.parentRequestId != null && false ) { // whats jemserinternal indicator
                        color = 'purple';
                }
                // console.log( rowEntity );
                // console.log ( "Row Color is : " + color );
                
                if (rowEntity.rowColorClass === "redRow")
                    color = rowEntity.rowColorClass;
                
                return color;
        };







        $scope.getActions = function (request) {
                $scope.selectedRequest = request
                $scope.selected = request;
                console.log("this is the request");
                console.log($scope.selectedRequest);
                $scope.contextMenu = HomeService.getContextMenuSettings($scope.selectedRequest);
                console.log($scope.contextMenu);
                $scope.actions = $scope.selectedRequest.actions
                $scope.currentMarker = $scope.selectedRequest.address.address
                console.log($scope.actions);
                $scope.actions.forEach(function(action){
                        if(action.success === true)
                                action.successMessage = 'Success';
                        else if(action.success === false)
                                action.successMessage = 'Failure';
                        else
                                action.successMessage = 'Pending';
                });
                $scope.action_grid_options.data = $scope.actions


        }

        $scope.action_grid_options = {
                enableHorizontalScrollbar: 0,
                enableVerticalScrollbar: 0,
                showColumnFooter: true
        };

        $scope.action_grid_options.columnDefs = [
                {field: 'actorPersonId.name', name: 'Employee'},
                {field: 'actionType.description', name: 'Action'},
                {field: 'actionPriority.description', name: 'Priority',width:80},
                {field: 'acteePersonId.name', name: 'Contact'},
                //{field: 'dateScheduled', name: 'Scheduled', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'},
                {field: 'dateCompleted', name: 'Completed', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'},
                {field: 'successMessage', name: 'Success',width:80},
                {field: 'comment', name: 'Comments'}
        ];

        $scope.createAction = function (request, actionType, completed) {
                var waitHere = $q.defer();
                $scope.action = HomeService.buildAction(request, actionType, completed);
                console.log("this is the action");
                console.log($scope.action);

                HomeService.createAction($scope.action).then(function (data) {
                        console.log("the response is");
                        console.log(data);
                        if (actionType === $scope.actionDefinitions.type.requestInWarehouse) {
                                $scope.createAction(request, $scope.actionDefinitions.type.assignEquipment);
                        }
                        waitHere.resolve(true);
                })
                $scope.load();
                return waitHere.promise;
        };

        $scope.AssignDriverAction = function (action) {
                if ($scope.selectedRequest != null) {
                        $scope.selectedAction = action;
                        var modalInstance = $uibModal.open({
                                animation: $scope.animationsEnabled,
                                templateUrl: 'templates/modals/assignDriverModal.html',
                                controller: 'DriversCtrl',
                                size: 'lg',
                                scope: $scope
                        });
                }
        };

        $scope.setDriver = function () {

                console.log("the selected request is");
                console.log($scope.selectedRequest);

                if ($scope.selectedRequest.requestType.id === RequestTypeDefinitions.get().DELIVERY.id ||
                        $scope.selectedRequest.requestType.id === RequestTypeDefinitions.get().COLLECTION.id ||
                        $scope.selectedRequest.requestType.id === RequestTypeDefinitions.get().CHANGEOVER.id ||
                        $scope.selectedRequest.requestType.id === RequestTypeDefinitions.get().REPAIR.id ||
                        $scope.selectedRequest.requestType.id === RequestTypeDefinitions.get().OTHER.id) {

                        console.log("I'm a delivery");
                        $scope.dateToUse = ActionFactory.checkDate($scope.selectedRequest.requiredDate);
                        console.log("the date is");
                        console.log($scope.dateToUse);
                        if (!ActionFactory.checkActionTypeExists($scope.selectedRequest, ActionDefinitions.get().type.inTransit)) {

                                $scope.action = HomeService.buildAction($scope.selectedRequest, ActionDefinitions.get().type.inTransit, false);

                                return $scope.action;
                        } else {
                                alert("A Driver has already been assigned or A Delivery action has been completed")
                        }
                        ;

                }
                ;

                if ($scope.selectedRequest.requestType.id === ActionDefinitions.get().type.collection) {

                        $scope.dateToUse = ActionFactory.checkDate($scope.selectedRequest.requiredDate);

                        if (!ActionFactory.checkActionTypeExists($scope.selectedRequest, ActionDefinitions.get().type.inTransit)) {

                                $scope.action = HomeService.buildAction($scope.selectedRequest, ActionDefinitions.get().type.inTransit, false);

                                $scope.AssignDriverAction($scope.action);
                        } else {
                                alert("A Driver has already been assigned or A collection action has been completed")
                        }
                        ;

                }
                ;


        }


        $scope.addDriver = function () {


                $scope.driverAction = $scope.setDriver();
                console.log("this is the driver action");
                console.log($scope.driverAction);
                console.log($scope.selected.actorPersonId);

                $scope.driverAction.actorPersonId = $scope.selected.actorPersonId;

                HomeService.createAction($scope.driverAction).then(function (data) {
                        console.log("the response is");
                        console.log(data);

                        //Creating contract once assiging driver
                        HomeService.createContractFromRequest($scope.selectedAction.id, 6).then(function (data) {
                                console.log("the response is");
                                console.log(data);

                                $scope.load();
                                modalInstance.close();
                        })



                })
                //$scope.createAction($scope.selectedAction, ActionDefinitions.get().type.inTransit);

        }







        $scope.open1 = function () {
                $scope.popup1.opened = true;
        };

        $scope.open2 = function () {
                $scope.popup2.opened = true;
        };


        //From date popup
        $scope.popup1 = {
                opened: false
        };

        $scope.toggleFiltering = function () {
                $scope.home_grid_options.enableFiltering = !$scope.home_grid_options.enableFiltering;
                $scope.gridApi.core.notifyDataChange(uiGridConstants.dataChange.COLUMN);
        };

        //To Date popup
        $scope.popup2 = {
                opened: false
        };

        $scope.createOffhire = function () {
                var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'templates/jemserinternal/modals/offhire.html',
                        controller: 'OffhireCtrl',
                        size: 'lg',
                        scope: $scope
                });
        };

        $scope.verifyQuote = function() {
                
                if ($scope.selectedRequest === null || $scope.selectedRequest === undefined)
                        return false;
                $scope.header = "Quotation"
                var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'templates/jemserinternal/modals/verifydocumentmodal.html',
                        controller: 'VerifyDocumentModalCtrl',
                        backdrop: 'static',
                        windowClass: 'request-modal-window',
                        scope: $scope
                });

                modalInstance.result.then(function () {
                        console.info('OK: Modal dismissed at: ' + new Date());
                        $scope.acceptQuoteCreation();
                }, function () {
                        console.info('CANCEL: Modal dismissed at: ' + new Date());
                        $scope.declineQuoteCreation();
                });

        };
        
        $scope.createQuote = function () {
                $scope.verifyQuote();
                
                $scope.acceptQuoteCreation = function(){
                        HomeService.createDocumentFromRequest(101, $scope.selectedRequest.id, $scope.selectedRequest.responderBusinessEntityBean.id).then(function (data) {
                                console.log("the response is");
                                console.log(data);
                                $scope.load();

                        });
                        $scope.load();
                };
                
                $scope.declineQuoteCreation = function(){
                        console.log("qoute creation declined")
                };
        };


});




diaryControllers.controller('DriversCtrl', function ($scope, $state, HomeService,ClientConfigDefinitions, $q, ActionFactory, ActionDefinitions, RequestStatusDefinitions, uiGridConstants, $uibModal, $uibModalInstance, RequestTypeDefinitions) {


        $scope.alreadyClicked = false;
        
        $scope.setDriver = function () {

                console.log("the selected request is");
                console.log($scope.selectedRequest);

                if ($scope.selectedRequest.requestType.id === RequestTypeDefinitions.get().DELIVERY.id ||
                        $scope.selectedRequest.requestType.id === RequestTypeDefinitions.get().COLLECTION.id ||
                        $scope.selectedRequest.requestType.id === RequestTypeDefinitions.get().CHANGEOVER.id ||
                        $scope.selectedRequest.requestType.id === RequestTypeDefinitions.get().REPAIR.id ||
                        $scope.selectedRequest.requestType.id === RequestTypeDefinitions.get().OTHER.id) {

                        console.log("I'm a delivery");
                        $scope.dateToUse = ActionFactory.checkDate($scope.selectedRequest.requiredDate);
                        console.log("the date is");
                        console.log($scope.dateToUse);
                        if (!ActionFactory.checkActionTypeExists($scope.selectedRequest, ActionDefinitions.get().type.inTransit)) {

                                $scope.action = HomeService.buildAction($scope.selectedRequest, ActionDefinitions.get().type.inTransit, false);

                                return $scope.action;
                        } else {
                                alert("A Driver has already been assigned or A Delivery action has been completed");
                        }
                        ;

                }
                ;

                if ($scope.selectedRequest.requestType.id === ActionDefinitions.get().type.collection) {

                        $scope.dateToUse = ActionFactory.checkDate($scope.selectedRequest.requiredDate);

                        if (!ActionFactory.checkActionTypeExists($scope.selectedRequest, ActionDefinitions.get().type.inTransit)) {

                                $scope.action = HomeService.buildAction($scope.selectedRequest, ActionDefinitions.get().type.inTransit, false);

                                $scope.AssignDriverAction($scope.action);
                        } else {
                                alert("A Driver has already been assigned or A collection action has been completed")
                        }
                        ;

                }
                ;


        }

        $scope.verifyDriver = function () {

                if ($scope.selectedRequest === null || $scope.selectedRequest === undefined) {
                        return false;
                }
                $scope.header = "Contract";
                var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'templates/jemserinternal/modals/verifydocumentmodal.html',
                        controller: 'VerifyDocumentModalCtrl',
                        backdrop: 'static',
                        //size: 'lg',
                        windowClass: 'request-modal-window',
                        scope: $scope
                });

                modalInstance.result.then(function () {
                        console.info('OK: Modal dismissed at: ' + new Date());
                        $scope.accept();
                }, function () {
                        console.info('CANCEL: Modal dismissed at: ' + new Date());
                        $scope.decline();
                });

        };
        
        $scope.addDriver = function () {
                if($scope.alreadyClicked){
                        console.log("prevented subsequent requests to assign driver");
                        return true;
                }
                $scope.alreadyClicked = true;
                console.log( "add driver ");
                console.log($scope.selectedRequest);
                
                $scope.accept = function(){
                        $scope.driverAction = $scope.setDriver();
                        
                         if ($scope.selectedRequest.driver != null) {
                            $scope.driverAction.actionType.id = 2013;
                            $scope.driverAction.success = true;
                            $scope.driverAction.dateCompleted = new Date();
                            console.log($scope.driverAction);
                        }
                        
                        console.log("this is the driver action");
                        console.log($scope.driverAction);
                        console.log($scope.selected.actorPersonId);
                        $scope.driverAction.actorPersonId = $scope.selected.actorPersonId;
                        HomeService.createAction($scope.driverAction).then(function (data) {
                                console.log("the response is");
                console.log(data);
                if ($scope.selectedRequest.requestType.id === 2000) {
                    
                    $scope.createContract = true;
                    angular.forEach($scope.selectedAction.requestToDocumentMapBeans, function (value, key) {
                        if ($scope.createContract === true) {
                            if (value.mappingDocumentTypeId === 1) {
                                $scope.createContract = false;
                            }
                        }
                    });
                } else if ($scope.selectedRequest.requestType.id === 2001 && ($scope.selectedRequest.driverId === null || $scope.selectedRequest.driverId === undefined)) {
                    $scope.updateSigCapQueue = true;
                }
                //Creating contract once assiging driver

                if ($scope.createContract === false || $scope.createContract === true) {
                        if(angular.fromJson(sessionStorage.clientConfig) === ClientConfigDefinitions.get().PPS){
                          HomeService.createDocumentFromRequest(12, $scope.selectedAction.id, $scope.selectedAction.responderBusinessEntityBean.id).then(function (data) {
                        console.log("the response is");
                        console.log(data);

                        $scope.load();
                        $uibModalInstance.close();
                        });      
                        }
                    else{
                    HomeService.createDocumentFromRequest(100, $scope.selectedAction.id, $scope.selectedAction.responderBusinessEntityBean.id).then(function (data) {
                        console.log("the response is");
                        console.log(data);

                        $scope.load();
                        $uibModalInstance.close();
                    });
                        }
                } else if ($scope.updateSigCapQueue === true) {

                    $scope.gotMap = false;
                    $scope.map = {};
                    angular.forEach($scope.selectedAction.requestToDocumentMapBeans, function (value, key) {
                        if ($scope.gotMap === false) {
                            if (value.mappingDocumentTypeId === 2) {

                                $scope.map = value;
                                $scope.gotMap = true;
                            }
                        }
                    })
                }

                if ($scope.gotMap === true) {
                    $scope.documentNumber = $scope.map.documentNumber;
                    $scope.documentType = $scope.map.mappingDocumentTypeId;
                    $scope.driver = $scope.driverAction.actorPersonId.id;
                    $scope.responder = $scope.selectedRequest.responderBusinessEntityBean.id;
                    HomeService.updateSigCapQueue($scope.documentNumber, $scope.documentType, $scope.driver, $scope.responder).then(function (data) {


                        console.log("the update data is");
                        console.log(data);
                        $scope.load();
                        $uibModalInstance.close();

                    })
                } else {
                    console.log("no mapping found");
                    $scope.load();
                    $uibModalInstance.close();
                }
            });
                };
                
                $scope.decline = function(){
                        console.log("do not proceed");
                        $scope.load();
                        $uibModalInstance.close();
                };
                //$scope.createAction($scope.selectedAction, ActionDefinitions.get().type.inTransit);
                
                if ($scope.selectedRequest.requestType.id === 2000 && $scope.selectedRequest.driver === null) {
                    $scope.verifyDriver();
                }else{
                    $scope.accept();
                }
        }

        $scope.cancel = function () {
                $uibModalInstance.close();
                console.log("I'm a delivery");
                $scope.dateToUse = ActionFactory.checkDate($scope.selectedRequest.requiredDate);
                console.log("the date is");
                console.log($scope.dateToUse);
            

               $scope.action = HomeService.buildAction($scope.selectedRequest, ActionDefinitions.get().type.inTransit , false);
                              
                return $scope.action;
            
          
            ;
            
        };
        
        
                   
        
        
    
        });
    
    


