diaryServices.factory('HomeService', function ($q, $http, Configuration, $log,$filter, EquipmentTypeDefinitions,  ActionDefinitions, RequestStatusDefinitions, RequestTypeDefinitions) {


    
    
    var buildSearchBean = function (){
        var bean = {};
        bean.fromDate = new Date();
        bean.toDate = new Date();
        bean.driverId = null;
        bean.requestTypeId = [0];
        bean.showComplete = false;
        bean.useDate = false;
        bean.completeOnly = false;
        bean.sourceBusinessEntityBean = {id: sessionStorage.companyId};
        bean.responderBusinessEntityBean = {id: sessionStorage.companyId };
        bean.user = null;
        bean.searchForPhone = false;
        
        return bean  
    };
    
    var removeRowsWithDrivers = function( requests ){
//        console.log("This is the factory requests")
//        console.log(requests)
      var filteredRequests = [];
       angular.forEach(requests, function(each){
//           console.log("in the for loop");
//           console.log(each);
            if( each.driver == null ){
//                console.log("in the if statement")
                    filteredRequests.push(each);
//                    console.log("this is the filtered list");
//                    console.log(filteredRequests);
            };
        });
      
      
      return filteredRequests;
    };
    
    var buildRequestBean = function(){
        
        console.log("building bean");
        var bean = {};
        
        bean.id = 0;
        bean.requestType = null;
        bean.requestStatus = {id: 1001};
        bean.runCategoryBean = null;
        bean.creationDate = new Date();
        bean.completionDate = null;
        bean.requiredDate = new Date();
        bean.responseDeadline = null;
        bean.user = {id: angular.fromJson(sessionStorage.personId)};
        bean.contact = null;
        bean.driver = null;
        bean.businessEntityBean = null;
        bean.responderBusinessEntityBean = null;
        bean.parentRequestId = null;
        bean.initialCreationDate = new Date();
        bean.requestReference = null;
        bean.daily = null;
        bean.weekly = null;
        bean.sales = null;
        bean.jemserProductBean = null;
        bean.jemserProductQty = 0;
        bean.address = null;
        bean.actions = [null];
        bean.description = null;
        bean.jemserProjectBean = null;
        bean.jemserProducts = [];
        
        return bean;
        
    }
    
    var getRequests = function (searchBean) {
        console.log("getting requests");
        console.log(searchBean);
        var documentPostPromise = $q.defer();
        $http({method: 'POST', data: searchBean, url: Configuration.getConfiguration().requestListSearchUrl}).
                success(function (data, status, headers, config) {
                    //console.log("Success , synced doc to backend");

                    // only remove document from list on a status = 'SUCCESS' response from server
                    //console.log(databaseDoc);
                    //console.log("sync returnDTO");
                    console.log(data);

                   
                        documentPostPromise.resolve(data);

                  
                }).
                error(function (data, status, headers, config) {
                    console.log("sync Failure");
                    documentPostPromise.reject(data);

                });

        return documentPostPromise.promise;
    };
    
    var updateSigCapQueue = function (docNumber, docType, driver,responder) {
        
        var getPromise = $q.defer();
        $log.info("pre updating sigcapQueue");
        $log.info(Configuration.getConfiguration().updateSigCapQueueUrl + docNumber + '/' + docType + '/' + driver + '/' + responder);
        $http.get(Configuration.getConfiguration().updateSigCapQueueUrl + docNumber + '/' + docType + '/' + driver + '/' + responder).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    
    
    
    var getRequestById = function (requestId) {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get single request");
        $log.info(Configuration.getConfiguration().getRequestByIdUrl + requestId);
        $http.get(Configuration.getConfiguration().getRequestByIdUrl + requestId).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var getRequestByCustomer = function (customerId) {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get rquest for customer");
        $log.info(Configuration.getConfiguration().getRequestsForCustUrl + customerId);
        $http.get(Configuration.getConfiguration().getRequestsForCustUrl + customerId).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var getEmployees = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get employees");
        $log.info(Configuration.getConfiguration().employeeListUrl + angular.fromJson(sessionStorage.companyId));
        $http.get(Configuration.getConfiguration().employeeListUrl + angular.fromJson(sessionStorage.companyId)).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var buildAction = function(request, actionType, completed){
        var definitions = ActionDefinitions.get();
        var action = buildPendingAction(request);
        if(completed === true){
        action.dateCompleted = new Date();
        action.success = true;
        }
        action.actionType.id = actionType;
        action.actionPriority.id = definitions.priority.medium;
        
             
        return action
    }
    
    
     
    
    
    var buildPendingAction = function(request) {
        
        
        var actionBean = {};
        actionBean.id = 0;
        actionBean.actionType = {};
        actionBean.actionPriority = {};
        actionBean.seq = 0;
        actionBean.actorPersonId = {id: sessionStorage.personId};
        actionBean.acteePersonId = request.contact;
        actionBean.comment = null;
        actionBean.createdByPersonId = {id: sessionStorage.personId};
        actionBean.requestId = request.id;
        actionBean.success = null;
        actionBean.customerName = request.businessEntityBean.name;
        actionBean.siteAddress = request.address.addres;
        if ( request.responderBusinessEntityBean != null)
             actionBean.responderBusinessEntity = {id: request.responderBusinessEntityBean.id };
        else
            actionBean.responderBusinessEntity = {id: sessionStorage.companyId};
        actionBean.dateCreated = new Date();
        if(request.requiredDate !== null){
           actionBean.dateScheduled = request.requiredDate; 
        }
        else{
          actionBean.dateScheduled = null;  
        }
        
        actionBean.dateCompleted = null;
        
        return actionBean;
    };
    
    
    var getContextMenuSettings = function(request){
        console.log(request);
        var context = {noOption : true};
        var actionDefinitions = ActionDefinitions.get();
        context.requestType = request.requestType.id;
        context.crossHire = false;
        request.requestToJemserProductMapBeans.forEach(function(product){
                if(product.crosshire === true)
                        context.crossHire = true;
        });
        var requestDefinitions = RequestStatusDefinitions.get();
        var requestTypeDefinitions = RequestTypeDefinitions.get();
        var equipmentTypeDefinitions = EquipmentTypeDefinitions.get();
        companyId = angular.fromJson(sessionStorage.companyId);
        console.log("this is the definitions");
        console.log(requestDefinitions);
        if(request.requestStatus.id === requestDefinitions.UNASSIGNED.id && request.businessEntityBean.id !== companyId){
            context.showAccept = true;
            context.showReject = true;
            context.showClone = true;
            context.noOption = false;
        }
        if(request.requestStatus.id === requestDefinitions.AWAITINGPURCHASEORDER.id && request.businessEntityBean.id === companyId){
            context.showIssuePurchase = true;
            context.noOption = false;
        }
        if(request.requestStatus.id === requestDefinitions.ISSUEDPURCHASEORDER.id && request.businessEntityBean.id !== companyId){
            context.showApprovePurchase = true;
            context.noOption = false;
        }
        if(request.requestStatus.id === requestDefinitions.AWAITINGAPPROVAL.id && request.businessEntityBean.id === companyId){
            context.showApproveRequest = true;
            context.noOption = false;
        }
        
        if(request.requestStatus.id !== requestDefinitions.COMPLETED.id && request.businessEntityBean.id === companyId){
            context.showCancelRequest = true;
            context.noOption = false;
        }
        
        if(request.requestStatus.id === requestDefinitions.COMPLETED.id && request.requestType.id === requestTypeDefinitions.DELIVERY.id && request.businessEntityBean.id === companyId){
            context.showBreakdown = true;
            context.showCollection = true;
            context.noOption = false;
        }
        
        if(request.requestStatus.id === 1009){
             context.assignDriver = false;
             context.assignToWarehouse = false;
        }
        else{
        if(request.requestType.id === requestTypeDefinitions.DELIVERY.id){
            
            context.offhire = false;
            context.assignDriver = true;
            context.quotation = true;
            context.assignToWarehouse = true;
            var isUnspecifiedSingle = false;
            console.log("this is the action definitions")
            console.log(actionDefinitions.type.assignEquipment);
            
            angular.forEach(request.actions, function(key, value){
                
              if(key.actionType.id === actionDefinitions.type.assignEquipment && key.dateCompleted == null ){
                  context.assignToWarehouse = false;
                  context.alreadyInWarehouse = true;
                  context.assignDriver = false;
              }
              
              
            });
            
            angular.forEach(request.requestToJemserProductMapBeans, function(key, value){
                    console.log("this is the equipment");
                    console.log(key);
                    console.log(key.jemserProductId.productClassBean);
                    console.log(key.crosshire);
                    if(key.jemserProductId.productClassBean.id === 4 && key.crosshire === false){
                         context.assignDriver = false;
                    }
                    console.log(isUnspecifiedSingle);
            })
            if(request.deliveryId === null || request.deliveryId === undefined){
                context.splitDelivery = true;    
            }
             angular.forEach(request.requestToDocumentMapBeans, function(key, value){
                
               if(key.mappingDocumentTypeId === 5){
                            context.quotation = false;
                        } 
            });
            
        }
        
         if(request.requestType.id === requestTypeDefinitions.COLLECTION.id){
             
            console.log("running collection menu config");
             
            context.quotation = false;
            context.offhire = true;
            context.assignDriver = true;
            context.assignToWarehouse = false;
            angular.forEach(request.requestToDocumentMapBeans, function(key, value){
                
               if(key.mappingDocumentTypeId === 2){
                            context.offhire = false;
                        } 
            });
        }
        
        }
        
       
        
        
        
        
        
        return(context);
    }
    
    var createAction = function (action) {
        //var databaseDoc = angular.copy(data.doc);

        console.log("syncing document");
        console.log(action);
        var documentPostPromise = $q.defer();
        $http({method: 'POST', data: action, url: Configuration.getConfiguration().createActionListUrl}).
                success(function (data, status, headers, config) {
                    //console.log("Success , synced doc to backend");

                    // only remove document from list on a status = 'SUCCESS' response from server
                    //console.log(databaseDoc);
                    //console.log("sync returnDTO");
                    //console.log(data);

                    if (data.status === 'SUCCESS') {
                        //For Test only saves me continually creating documents to sync
                        console.log("Sync Successful");
                        documentPostPromise.resolve(true);

                    } else {
                        console.log("sync Failure");
                        documentPostPromise.reject(true);

                    }

                }).
                error(function (data, status, headers, config) {
                    console.log("sync Failure");
                    documentPostPromise.reject(true);

                });

        return documentPostPromise.promise;
    };
    

     var getProfile = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Jemser Profile");
        $http.get(Configuration.getConfiguration().getProfileUrl + angular.fromJson(sessionStorage.personId)).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    
    var createDocumentFromRequest = function (documentType, requestId) {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre creating easi hire document");
        $http.get(Configuration.getConfiguration().createEasiHireDocumenttUrl + angular.fromJson(sessionStorage.companyId) + '/' + documentType + '/' + requestId).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var createContractFromRequest = function (requestId,documentType ) {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre creating easi hire document");
        $http.get(Configuration.getConfiguration().createContractFromOrderUrl + requestId + '/' + angular.fromJson(sessionStorage.companyId) + '/' + documentType).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var createReturnFromOffhire = function( requestId ){
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("");
        $http.get(Configuration.getConfiguration().createReturnFromOffhireUrl + requestId ).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var reverseOffHire = function( requestId ){
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("");
        $http.get(Configuration.getConfiguration().reverseoffHireUrl + requestId ).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };

    return{
        
        buildSearchBean: buildSearchBean,
        getRequests: getRequests,
        buildAction : buildAction,
        createAction: createAction,
        getProfile: getProfile,
        buildRequestBean: buildRequestBean,
        getContextMenuSettings: getContextMenuSettings,
        getEmployees: getEmployees,
        getRequestById: getRequestById,
        removeRowsWithDrivers: removeRowsWithDrivers,
        createDocumentFromRequest: createDocumentFromRequest,
        createContractFromRequest: createContractFromRequest,
        getRequestByCustomer: getRequestByCustomer,
        updateSigCapQueue: updateSigCapQueue,
        createReturnFromOffhire: createReturnFromOffhire,
        reverseOffHire: reverseOffHire
    };
});

