diaryControllers.controller('ActionScreenCtrl', function ($filter,HomeService,
$scope,ConfirmModalService, ActionFactory, 
$uibModal,$state,RequestTypeDefinitions) {
    
    var actionStatus = {};
    $scope.driverEquipment = {};
    $scope.selectedRow = {};
    
    HomeService.getEmployees().then(function (employees) {
        $scope.employees = employees.data;
    });
    
    $scope.selectedActionEntity = function (rowEntity) {
        console.log("this is the action");
        console.log(rowEntity);
        $scope.contextMenuEntityAction = rowEntity.action;
        $scope.selectedRow = rowEntity;
        $scope.selectedAction = rowEntity;
        $scope.isActionSelected(rowEntity);
        $scope.driverEquipmentGridOptions.data = $scope.selectedRow.detailLineBeans;
        
    };
    
    $scope.isActionSelected = function (rowEntity) {
         
        if ($scope.contextMenuEntityAction == null)
            return false;
        return $scope.contextMenuEntityAction.id === rowEntity.action.id;
    };
    
    //$scope.diaryUrl = ClientConfig.route('templates/driversactions/actionScreen.html');
    $scope.changeDriver = function(){
                var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'templates/modals/assignDriverModal.html',
                        controller: 'ChangeDriversCtrl',
                        size: 'lg',
                        scope: $scope
                });
                console.log($scope.selectedRow);
    };
    
    $scope.checkboxes = {
        showComplete: false,
        showDateFilter: false
    };
    $scope.driverId = null;
    
     $scope.clearDriverSearch = function (){
        console.log("clearing");
        $scope.driverId = null;
        $scope.filterSelected.employee = undefined;
    }
    
    
     $scope.filterSelected = {};
    $scope.filterSelected.employee = undefined;
    $scope.filterSelected.requestType = {id: 0, description: 'All'};
    $scope.filterSelected.fromDate = new Date();
    $scope.filterSelected.toDate = new Date();
    $scope.filterSelected.assigned = false;
    
    
    $scope.fromDate = new Date();
    $scope.toDate = new Date();
    $scope.driverId = null;
    
    $scope.taskGridOptions = {
        showColumnFooter: true,
        enableHorizontalScrollbar: 0,
        enableVerticalScrollbar: 0,
        rowTemplate: 'templates/jemserinternal/rows/driveractionrowtemplate.html',
        columnDefs: [{field: 'action.requestId', name:'Request Id', type: 'number'},
                {field: 'customerName', name:'Customer Name'},
                {field: 'siteAddress', name:'Site'},
                {field: 'firstItemDescription', name:'First Item'},
                {field: 'documentType', name: 'Document Type'}, //, cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'
                {field: 'documentNumber', name:'Doc Number', type: 'number'},
                {field: 'driverName', name:'Driver'},
                {name: 'blank', width:'100'}
        ]
    };
    
    $scope.driverEquipmentGridOptions = {
         columnDefs: [
                {field: 'jemserProductId.cod', name:'COD'},
                {field: 'jemserProductId.description', name:'Equipment'},
                {field: 'qty', name:'Quantity', type: 'number'},
                {field: 'site.address', name:'Site'}                
        ]   
    };
    
    $scope.load = function () {
        console.log("loading the requests");
        
        console.log($scope.filterSelected.employee);
        $scope.loadingRequestSpinner = "glyphicon glyphicon-refresh spinning";
        if ($scope.filterSelected.employee !== undefined) {
            $scope.driverId = $scope.filterSelected.employee.id;
         };
         
         /*if($scope.filterSelected.requestType.length > 1){
             var count = 0;
             
             while (count < $scope.filterSelected.requestType.length)
             {
             $scope.filterSelected.requestTypeIds     
             }
         }*/
        
        
        //if there is an id it was made through the dropdown so convert it to an array
        if($scope.filterSelected.requestType.id != null){
            $scope.filterSelected.requestType = [$scope.filterSelected.requestType.id];
        }
        
        $scope.filterSelected.fromDate.setHours(00);
        $scope.filterSelected.fromDate.setMinutes(00);
        $scope.filterSelected.toDate.setHours(23);
        $scope.filterSelected.toDate.setMinutes(59);
        $scope.complete = $scope.showComplete;
        $scope.filterBean = {
            fromDate: $scope.filterSelected.fromDate,
            toDate: $scope.filterSelected.toDate,
            driverId: $scope.driverId,
            requestTypeId: $scope.filterSelected.requestType,
            showComplete: $scope.checkboxes.showComplete,
            useDate: $scope.checkboxes.showDateFilter
        };

        console.log("Filter BEan");
        console.log($scope.filterBean);

        ActionFactory.actionSearch($scope.filterBean).then(function (actions) {
            
             $scope.actions = actions.data; 
                console.log("this is the actions");
                   console.log($scope.actions);
                      
             
            
            $scope.taskGridOptions.data = $filter('filter')($scope.actions,{ actionType: {id: 2000}},true);
           
            var deliverys = $filter('filter')($scope.actions,{ actionType: {id: 1000}},true);
            var collections = $filter('filter')($scope.actions,{ actionType: {id: 1001}},true);
            var repairs = $filter('filter')($scope.actions,{ actionType: {id: 1003}},true);
            var others = $filter('filter')($scope.actions,{ actionType: {id: 1005}},true);
            var intransit = $filter('filter')($scope.actions,{ actionType: {id: 2000}},true);
            $scope.taskGridOptions.data = [];
            $scope.taskGridOptions.data.push.apply($scope.taskGridOptions.data,deliverys);
            $scope.taskGridOptions.data.push.apply($scope.taskGridOptions.data,collections);
            $scope.taskGridOptions.data.push.apply($scope.taskGridOptions.data,repairs);
            $scope.taskGridOptions.data.push.apply($scope.taskGridOptions.data,others);
            $scope.taskGridOptions.data.push.apply($scope.taskGridOptions.data,intransit);
            $scope.changeRequestType();
            
//            console.log($scope.taskGridOptions.data);
            $scope.loadingRequestSpinner = "";


        });

    };
    
    $scope.changeRequestType = function(){
        $scope.driverEquipmentGridOptions.data = [];
        var requestTypes = RequestTypeDefinitions.get();
        var type = 'NONE';
        switch($scope.driverEquipment.status){
                case 'NONE':
                        break;
                case 'DELIVERY':
                        type = requestTypes.DELIVERY.id;
                        break;
                case 'COLLECTION':
                        type = requestTypes.COLLECTION.id;
                        break;
                default:
                        break;
        }
        $scope.taskGridOptions.data.forEach(function(action){
                action.detailLineBeans.forEach(function(details){
                        if(action.requestType === type)
                                $scope.driverEquipmentGridOptions.data.push(details);
                })
        })
    }
    
    $scope.load();
    
    $scope.failAction = function (action) {
        console.log("failing action");
           console.log(action);
            $scope.selectedAction = action;
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'templates/modals/failactionmodal.html',
                controller: 'failActionModalCtrl',
                size: 'md',
                scope: $scope
            });
        
    };
    
    
    
    
    $scope.actionStatusChange = function (item, actionStatus) {
        console.log(item);
        console.log(actionStatus);
        var modalOptions = {
            closeButtonText: 'Cancel',
            actionButtonText: 'Ok',
            headerText: 'Mark Action ' + actionStatus + ' ?',
            bodyText: 'Are you sure you want to change the status of this action to  ' + actionStatus + '?'
        };

        ConfirmModalService.showModal({}, modalOptions)
                .then(function (result) {
                    // your-custom-logic
                    if (result) {
                        $scope.selectedAction = item;
                        
                        $scope.selectedAction.success = true;
                        $scope.selectedAction.dateCompleted = new Date();
                        console.log("going to mark it as complete");
                        console.log($scope.selectedAction);
            HomeService.createAction($scope.selectedAction).then(function (data) {
            console.log("synced");
            console.log(data.data);
            $scope.load();
           
        });
                        /*
                        var requestStatusChangeAction = ActionFactory.buildNewCompletedAction({actionType: {id: requestStatus.actionId},
                            actionPriority: {id: ActionDefinitions.get().priority.high}, actorPersonId: item.employee,
                            acteePersonId: item.contact, createdByPersonId: item.employee, requestId: item.requestId, comment: "Request Status Change"});
                        DiaryService.createAction(requestStatusChangeAction).then(function (data) {
                            $scope.load();
                            console.log("$scope.selectedRequest = ");
                            console.log($scope.selectedRequest);
                              


                        });*/
                    }
                });

    };
    
    
    $scope.completeActionAndCreateReturn = function(contextMenuEntityAction){
        console.log("im running create return");
        HomeService.createReturnFromOffhire(contextMenuEntityAction.requestId).then(function(result){
            if( result.data.status === 'SUCCESS'){
                // complete the driver action.
                //$scope.actionStatusChange(contextMenuEntityAction, 'COMPLETE');
                $scope.selectedAction = contextMenuEntityAction;
                $scope.selectedAction.success = true;
                $scope.selectedAction.dateCompleted = new Date();
                HomeService.createAction($scope.selectedAction).then(function (data) {
                    console.log("synced");
                    console.log(data.data);
                    $scope.load();
                });
            }
        });
    };
     $scope.verifyCollection = function(action){
        console.log("Verifying Collection");
        $scope.selectedAction = action;
        var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                backdrop: 'static',
                templateUrl: 'templates/jemserinternal/modals/verifycollection.html',
                controller: 'VerifyCollectionCtrl',
                windowClass: 'request-modal-window',
                scope: $scope
            });
            modalInstance.result.then(function () {
                
                        $scope.load();
            });
            $scope.load();
    };
    
    $scope.backButton = function(){
        console.log(" going back ");
        $state.go("base.hirehome");
    };

});

diaryControllers.controller('ChangeDriversCtrl', function ($scope, $state, HomeService, $q, ActionFactory, ActionDefinitions, RequestStatusDefinitions, uiGridConstants, $uibModal, $uibModalInstance, RequestTypeDefinitions) {

        $scope.alreadyClicked = false;
        $scope.selected = {};
        
        $scope.addDriver = function () {
                if($scope.alreadyClicked){
                        console.log("prevented subsequent requests to assign driver");
                        return true;
                }
                $scope.alreadyClicked = true;
                
                $scope.documentNumber = $scope.selectedRow.documentNumber;
                $scope.documentType = $scope.selectedRow.requestType; // this needs to be a document type eventually but doesnt seem to be used.
                $scope.driver = $scope.selected.actorPersonId.id;
                $scope.responder = $scope.selectedRow.action.responderBusinessEntity.id;
                console.log($scope.documentNumber + " " +$scope.documentType +" " +$scope.driver +" " + $scope.responder );
                console.log($scope.selectedRow.action);
                HomeService.updateSigCapQueue($scope.documentNumber, $scope.documentType, $scope.driver, $scope.responder).then(function (data) {
                        console.log("the update data is");
                        console.log(data);
                        $scope.selectedRow.action.actorPersonId = $scope.selected.actorPersonId
                        HomeService.createAction($scope.selectedRow.action).then(function (data) {
                            $scope.load();
                            console.log("$scope.selectedRequest = ");
                            console.log($scope.selectedRequest);



                        });
                        $scope.load();
//                        console.log($scope.selected);
//                        console.log($scope.selectedRow);
                        $uibModalInstance.close();
                });
                        
        };

        $scope.cancel = function () {
                $uibModalInstance.close();
        };
});

diaryControllers.controller('VerifyCollectionCtrl', function ($log,
    RequestTypeDefinitions, $scope,$q,
    WarehouseService,VerifyCollectionGridService,
    $uibModalInstance,PlantStatusDefinitions,
    RequestService ,HomeService, $uibModal,$state,ActionDefinitions) {
    
   $scope.okAlreadyClicked = false;
   
   $scope.plantStatusDefinitions = PlantStatusDefinitions.get();
   $scope.isAvailableSelected = function (rowEntity) {
      
        if ($scope.rowEntity === null || $scope.selectedRow === null || $scope.selectedRow === undefined){
            return false;
        }
        else{
            return  $scope.selectedRow.$$hashKey === rowEntity.$$hashKey;
        }
    };
    
   
   $scope.selectedProducts = [];
   
   $scope.group_options = VerifyCollectionGridService.getSingleItemsGrid();
   $scope.group_options.onRegisterApi = function(gridApi){
        $scope.gridApi = gridApi;
   }.bind(this);
    
     
    $scope.getSingleStatus = function(row){
        console.log("this is the available row");
    };
    
    
    $scope.multipleItemsGrid = VerifyCollectionGridService.getMultipleItemsGrid();
    $scope.consumableItemsGrid = VerifyCollectionGridService.getConsumableItemsGrid();
   
   WarehouseService.getPlantAvailability($scope.selectedAction.requestId).then(function(data){
       console.log(data.data);
       $scope.equipment = data.data.requestToJemserProductMapBeanSingleItems;
       $scope.multipleItems = data.data.requestToJemserProductMapBeanMultiples;
       $scope.consumableItems = data.data.requestToJemserProductMapBeanConsumables ;
       
       console.log("this is the equipment");
       console.log($scope.equipment);
       console.log($scope.multipleItems);
       console.log($scope.consumableItems);
       
       angular.forEach($scope.equipment,function(each){
            each.qtyCollected= each.qty; 
       });
       
       angular.forEach($scope.multipleItems,function(each){
            each.qtyCollected= each.qty; 
       });
       
       angular.forEach($scope.consumableItems,function(each){
              each.qtyCollected= each.qty; 
       });
       
       $scope.group_options.data = $scope.equipment;
       $scope.multipleItemsGrid.data = $scope.multipleItems;
       $scope.consumableItemsGrid.data = $scope.consumableItems;
   });
   
   
   
       
   
   
   $scope.isRequiredSelected = function (rowEntity) {
            
        if ($scope.rowEntity === null || $scope.selectedItem === null || $scope.selectedItem === undefined){
            return false;
        }
        else{
            
        return  $scope.selectedItem.availablePlantBean.id === rowEntity.availablePlantBean.id;
        }
    };
   
   
    $scope.setSingleItem = function(item){
       
   };
   
   $scope.addChosen = function(){
      
   };
   
   // checks the warehouse fulfilment to make sure all items are fulfilled.
   var validateWarehouseFulfilment = function(){
       var valid = true;
       angular.forEach($scope.equipment,function(singleItem,key){
           console.log(singleItem);
           if( singleItem.singleItem === undefined && 
                   ( singleItem.equipmentTypeBean.crosshire === undefined || singleItem.equipmentTypeBean.crosshire === false ) ){
                valid = false;
           };
       });
       angular.forEach($scope.multipleItems,function(multipleItem,key){
           //console.log(multipleItem);
           if( multipleItem.qty !== multipleItem.qtyAvailable ){
                valid = false;
           };
       });
            // handle setting qty available on consumable items
        angular.forEach($scope.consumableItems,function(consumableItem,key){
            if( consumableItem.qty !== consumableItem.qtyAvailable ){
                valid = false;
           };
        });
       return valid;
   };
   
   var completeAction = function(status,comment){
        var completeActionPromise = $q.defer();
        $scope.selectedAction.dateCompleted = new Date();
        $scope.selectedAction.success = status;
        $scope.selectedAction.comment = comment;
        HomeService.createAction($scope.selectedAction).then(function (data) {
             completeActionPromise.resolve(true);
        });
        return completeActionPromise.promise;
   };
   
   $scope.ok = function(){
           $scope.handleOk();
       
   };
   
   var handleSettingQtyCollected = function(){
        angular.forEach($scope.equipment,function(singleItem,key){
            console.log("singleItem");
            console.log(singleItem);
            console.log("$scope.request");
            console.log($scope.request);
           angular.forEach($scope.request.requestToJemserProductMapBeans,function(bean){
              console.log("bean qty collected")
              console.log( bean.jemserProductId.id + " === " + singleItem.jemserProductId.id );
              if( bean.jemserProductId.id === singleItem.jemserProductId.id ){
                  console.log("setting qty collected");
                  bean.qtyCollected = singleItem.qtyCollected;
              } 
           });
        }); 
       
       // handle setting qty available , and crosshire on multiple items
        angular.forEach($scope.multipleItems,function(multipleItem,key){
           angular.forEach($scope.request.requestToJemserProductMapBeans,function(bean){
              if( bean.jemserProductId.id === multipleItem.jemserProductId.id ){
                  bean.qtyCollected = multipleItem.qtyCollected;
              } 
           });
        });
        // handle setting qty available on consumable items
        angular.forEach($scope.consumableItems,function(consumableItem,key){
           angular.forEach($scope.request.requestToJemserProductMapBeans,function(bean){
              if( bean.jemserProductId.id === consumableItem.jemserProductId.id ){
                  bean.qtyCollected = consumableItem.qtyCollected;
              } 
           });
        });
   };
   
   $scope.handleOk = function(){
       if($scope.okAlreadyClicked){
                console.log("prevented multiple clicks to set equipment");
                return true;
       }
       $scope.okAlreadyClicked = true;
       HomeService.getRequestById($scope.selectedAction.requestId).then(function(data){
           console.log(data.data);
           $scope.request = data.data;
           //console.log($scope.equipment);
           
           
           
           // handle setting the qtyCollected 
           handleSettingQtyCollected();
           
           $scope.requestList = [];
           $scope.requestList.push($scope.request);
           // we are cloning this request so reset the id 
           var returnRequest = angular.copy($scope.request);
           returnRequest.id = 0;
           returnRequest.creationDate = new Date();
           returnRequest.requestType = RequestTypeDefinitions.get().RETURN.id;
           returnRequest.parentRequestId = $scope.request.id;
           // should i set the qty = qtyCollected in handleSettingQtyCollected above.
           $scope.requestList.push(returnRequest);
           
           
            $scope.requests = {};
            $scope.requests.jemserRequestBeans = $scope.requestList;
            console.log("here are the reqests");
            console.log($scope.requests);
            RequestService.createRequests($scope.requests).then(function (request) {
                console.log("synced");
                console.log(request);
                
                $scope.selectedAction.dateCompleted = new Date();
                $scope.selectedAction.success = true;
                
                completeAction(true,"Collected").then(function(result){
                            $scope.selectedAction.actionType = ActionDefinitions.get().type.verifyCollection;
                            $scope.selectedAction.createdByPersonId = {id : sessionStorage.personId};
                            $scope.selectedAction.actorPersonId = {id : sessionStorage.personId};
                            completeAction(true,"Verifyed").then(function(result){
                                $scope.load();
                                $uibModalInstance.close();
                            });
                });

            });
       });
       /*$scope.selectedProducts.push($scope.selectedItem);
       console.log($scope.selectedProducts);
       $uibModalInstance.close();*/
   };
   
   
   $scope.cancel = function(){
     console.log("cancelling"); 
     $uibModalInstance.close();
   };
   
});
