diaryServices.factory('InternalEquipmentService',function($q,$http,Configuration,$log){
  
    var getInternalProducts = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Jemser Products");
        $log.info(Configuration.getConfiguration().getInternalProductsEndpointUrl);
        $http.get(Configuration.getConfiguration().getInternalProductsEndpointUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    
    
    var getAllInternalProducts = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get all Jemser Products");
        $log.info(Configuration.getConfiguration().getAllJemserProductsUrl);
        $http.get(Configuration.getConfiguration().getAllJemserProductsUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var getAccessories = function(jemserProductId){
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get all accessories");
        $log.info(Configuration.getConfiguration().getAccessoriesUrl + jemserProductId);
        $http.get(Configuration.getConfiguration().getAccessoriesUrl + jemserProductId ).then(function (data) {
            //$log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    }
    
    var getJemserProductDetailLine = function(custId,jemserProductId,seqNumber){
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get all accessories");
        
        if( custId === undefined ){
            custId = 0;
        }
        
        $log.info(Configuration.getConfiguration().getJemserProductDetailLineUrl + custId + "/" + jemserProductId +"/" +seqNumber);
        $http.get(Configuration.getConfiguration().getJemserProductDetailLineUrl  + custId + "/" + jemserProductId +"/" +seqNumber ).then(function (data) {
            //$log.info(data);
            console.log(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    }
    
    
    
    return {
        getInternalProducts: getInternalProducts,
        getAllInternalProducts: getAllInternalProducts,
        getAccessories : getAccessories,
        getJemserProductDetailLine : getJemserProductDetailLine
    };
    
    
    
    
   
});