diaryControllers.controller('warehouseScreenCtrl', function ($log,
    /*ConfirmModalService,*/ $scope,$filter, /*DiaryService,*/ ActionFactory,HomeService,PlantStatusDefinitions, $uibModal,$state/*,RunWarehouseReportService,ViewReportService*/) {
    
    var actionStatus = {};
    /*DiaryService.getEmployees().then(function (employees) {
        $scope.employees = employees.data;
    });*/
    
    

    $scope.selectedActionEntity = function (rowEntity) {
        $log.info(rowEntity);
        $scope.contextMenuEntityAction = rowEntity.action;
    };
    
    $scope.isActionSelected = function (rowEntity) {
        if ($scope.contextMenuEntityAction == null)
            return false;
        return $scope.contextMenuEntityAction.id === rowEntity.action.id;
    };
    
    //$scope.diaryUrl = ClientConfig.route('templates/warehouse/warehouseScreen.html');
    
    $scope.checkboxes = {
        showComplete: false,
        showDateFilter: false
    };
    $scope.driverId = null;
    
     $scope.clearDriverSearch = function (){
        console.log("clearing");
        $scope.driverId = null;
        $scope.filterSelected.employee = undefined;
    };
    
    
    $scope.setPlant = function(action){
        console.log("setting plant");
        $scope.selectedAction = action;
        var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                backdrop: 'static',
                templateUrl: 'templates/jemserinternal/modals/chooseplant.html',
                controller: 'SelectPlantCtrl',
                windowClass: 'request-modal-window',
                scope: $scope
            });
            modalInstance.result.then(function () {
                        $scope.load();
            });
            $scope.load();
    }
    
    
    $scope.filterSelected = HomeService.buildSearchBean();
    
    console.log("this is the search");
            console.log($scope.filterSelected);
     //$scope.filterSelected = {};
    $scope.filterSelected.employee = undefined;
    $scope.filterSelected.requestType = {id: 0, description: 'All'};
    $scope.filterSelected.fromDate = new Date();
    $scope.filterSelected.toDate = new Date();
    $scope.filterSelected.assigned = false;
    
    
    $scope.fromDate = new Date();
    $scope.toDate = new Date();
    $scope.driverId = null;
    
   
    
    $scope.taskGridOptions = {
        rowTemplate: 'templates/jemserinternal/rows/actionrowtemplate.html',
        columnDefs: [  {field: 'requestId', name:'Request Id'},
                {field: 'customerName', name:'Customer Name'},
                {field: 'siteAddress', name:'Site'},
                {field: 'firstItemDescription', name:'First Item'},
                {name: 'blank', width:'100'}]
    };
    
    $scope.load = function () {
        console.log("loading the requests");
        
        console.log($scope.filterSelected.employee);
        $scope.loadingRequestSpinner = "glyphicon glyphicon-refresh spinning";
        if ($scope.filterSelected.employee !== undefined) {
            $scope.driverId = $scope.filterSelected.employee.id;
         };
         
         /*if($scope.filterSelected.requestType.length > 1){
             var count = 0;
             
             while (count < $scope.filterSelected.requestType.length)
             {
             $scope.filterSelected.requestTypeIds     
             }
         }*/
        
        
        //if there is an id it was made through the dropdown so convert it to an array
        if($scope.filterSelected.requestType.id != null){
            $scope.filterSelected.requestType = [$scope.filterSelected.requestType.id];
        }
        
        $scope.filterSelected.fromDate.setHours(00);
        $scope.filterSelected.fromDate.setMinutes(00);
        $scope.filterSelected.toDate.setHours(23);
        $scope.filterSelected.toDate.setMinutes(59);
        $scope.complete = $scope.showComplete;
        $scope.filterBean = {
            fromDate: $scope.filterSelected.fromDate,
            toDate: $scope.filterSelected.toDate,
            driverId: $scope.driverId,
            requestTypeId: $scope.filterSelected.requestType,
            showComplete: $scope.checkboxes.showComplete,
            useDate: $scope.checkboxes.showDateFilter
        };

        console.log("Filter BEan");
        console.log($scope.filterBean);

        ActionFactory.actionSearch($scope.filterBean).then(function (actions) {
            
             $scope.actions = actions.data; 
                console.log("this is the actions");
//                   console.log($scope.actions);
                      
             
                     
            $scope.taskGridOptions.data = $filter('filter')($scope.actions,{actionType:{id:2012}},true);
           
            console.log($scope.taskGridOptions.data);
            $scope.loadingRequestSpinner = "";


        });

    };
    
    $scope.load();
    
    $scope.failAction = function (action) {
        console.log("failing action");
        
            $scope.selectedAction = action;
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'templates/modals/failactionmodal.html',
                controller: 'failActionModalCtrl',
                size: 'md',
                scope: $scope
            });
        
    };
    
    
    $scope.actionStatusChange = function (item, actionStatus) {
        console.log(item);
        console.log(actionStatus);
        $scope.selectedAction = item;
        console.log(item);
        var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: ClientConfig.route('templates/modals/warehouseCompleteModal.html'),
                controller: 'warehouseCompleteModalCtrl',
                size: 'md',
                scope: $scope
            });
    };
  
    $scope.backButton = function(){
        console.log(" going back ");
        $state.go("base.hirehome");
    };   
    
    $scope.runWarehouseReport = function(){
        console.log("Heres my Actions");
        console.log($scope.taskGridOptions.data);
        RunWarehouseReportService.runWarehouseReport({jemserActionBeans: $scope.taskGridOptions.data}).then(function (data) {
            $log.info(data.data);
            ViewReportService.viewReport(data.data);
        });
    };
});




diaryControllers.controller('SelectPlantCtrl', function ($log,
    ConfirmModalService, $scope,$q, WarehouseService,$uibModalInstance,PlantStatusDefinitions, ChoosePlantGridService, RequestService ,HomeService, $uibModal,$state/*,RunWarehouseReportService,ViewReportService*/) {
    
   $scope.okAlreadyClicked = false;
   
   $scope.plantStatusDefinitions = PlantStatusDefinitions.get();
   $scope.isAvailableSelected = function (rowEntity) {
      
        if ($scope.rowEntity === null || $scope.selectedRow === null || $scope.selectedRow === undefined){
            return false;
        }
        else{
            return  $scope.selectedRow.$$hashKey === rowEntity.$$hashKey;
        }
    };
    
   
   $scope.selectedProducts = [];
   
   $scope.group_options = ChoosePlantGridService.getGroupOptionsGrid();
   $scope.group_options.onRegisterApi = function(gridApi){
        $scope.gridApi = gridApi;
   }.bind(this);
    
     
    $scope.getSingleStatus = function(row){
        console.log("this is the available row");
    };
    
    
    $scope.available_plant_options = ChoosePlantGridService.getAvailablePlantOptionsGrid();
    $scope.multipleItemsGrid = ChoosePlantGridService.getMultipleItemsGrid();
    $scope.consumableItemsGrid = ChoosePlantGridService.getConsumableItemsGrid();
    
//    $scope.chosen_plant_options = {
//        enableHorizontalScrollbar: 0,
//        enableVerticalScrollbar: 1,
//        showColumnFooter: false,
//        rowTemplate: 'templates/myequipment/categoryrow.html',
//    };
//
//    $scope.chosen_plant_options.columnDefs = [
//        {field: 'availablePlantBean.description',
//            name: 'Equipment'
//
//        },
//    ];
   
   console.log("this is the action");
   console.log($scope.selectedAction);
   WarehouseService.getPlantAvailability($scope.selectedAction.requestId).then(function(data){
       console.log(data.data);
       $scope.equipment = data.data.plantAvailablityEquipmentTypeBeans;
       $scope.multipleItems = data.data.requestToJemserProductMapBeanMultiples;
       $scope.consumableItems = data.data.requestToJemserProductMapBeanConsumables ;
       
       console.log("this is the equipment");
       console.log($scope.equipment);
       console.log($scope.multipleItems);
       console.log($scope.consumableItems);
       
       angular.forEach($scope.multipleItems,function(each){
          if( each.qtyAvailable === undefined || each.qtyAvailable === null ){
            each.qtyAvailable= each.qty; 
          };
       });
       
       angular.forEach($scope.consumableItems,function(each){
          if( each.qtyAvailable === undefined || each.qtyAvailable === null ){
              each.qtyAvailable= each.qty; 
          };
       });
       
       $scope.group_options.data = $scope.equipment;
       $scope.multipleItemsGrid.data = $scope.multipleItems;
       $scope.consumableItemsGrid.data = $scope.consumableItems;
   });
   
   $scope.setSpecificPlant = function(){
        console.log($scope.available_plant_options.data);
        
        var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'templates/jemserinternal/modals/choosespecificplant.html',
                controller: 'SelectSpecificPlantCtrl',
                size: 'md',
                scope: $scope
            });
            
            modalInstance.result.then(function () {
            console.info('Modal dismissed at: ' + new Date());
            $scope.chosen_plant_options.data = $scope.selectedProducts;
        }, function () {
            console.info('Modal dismissed at: ' + new Date());
        });
    }
   
   
   $scope.getAvailable = function(row){
       console.log("this is the row");
       console.log(row);
       
       $scope.selectedRow = row;
       $scope.availablePlants = row.availablePlantBeans;
       
       angular.forEach($scope.availablePlants, function(key, value){
           var plant = key;
           
           angular.forEach($scope.plantStatusDefinitions.type, function(key, value){
                  
               if(plant.stat === key.id){
                
                   plant.status = key.description;
               }
           })
       })
       // THIS REMOVED SOLD ITEMS!!!!!!!!!!!!!
       // REMOVE THIS IF SERVICE IS UPDATED TO REMOVE THEM BEFORE COMING TO CLIENT
       console.log($scope.availablePlants);
       var temporaryAvailablePlant = [];
       $scope.availablePlants.forEach(function(plant){
               if(plant.stat !== 7 && plant.stat !== 9)
                        temporaryAvailablePlant.push(plant);
       })
       $scope.available_plant_options.data = temporaryAvailablePlant;//$scope.availablePlants;
       
       
       //$scope.setSpecificPlant();
       
   }
   
   $scope.isRequiredSelected = function (rowEntity) {
            
        if ($scope.rowEntity === null || $scope.selectedItem === null || $scope.selectedItem === undefined){
            return false;
        }
        else{
            
        return  $scope.selectedItem.availablePlantBean.id === rowEntity.availablePlantBean.id;
        }
    };
   
   
    $scope.setSingleItem = function(item){
       console.log(item);
       $scope.selectedItem = item;
       
       $scope.addChosen();
       
       
       
   };
   
   $scope.addChosen = function(){
       console.log("adding chosen");
       $scope.selectedRow.singleItem = $scope.selectedItem;
       $scope.selectedRow.singleItem.codDescription = ($scope.selectedItem.availablePlantBean.cod + ' - ' + $scope.selectedItem.availablePlantBean.description);
       $scope.selectedRow.chosen = true;
       console.log($scope.selectedRow);
       //$uibModalInstance.close();
   };
   
   // checks the warehouse fulfilment to make sure all items are fulfilled.
   var validateWarehouseFulfilment = function(){
       var valid = true;
       angular.forEach($scope.equipment,function(singleItem,key){
           console.log(singleItem);
           if( singleItem.singleItem === undefined && 
                   ( singleItem.equipmentTypeBean.crosshire === undefined || singleItem.equipmentTypeBean.crosshire === false ) ){
                valid = false;
           };
       });
       angular.forEach($scope.multipleItems,function(multipleItem,key){
           //console.log(multipleItem);
           if( multipleItem.qty !== multipleItem.qtyAvailable ){
                valid = false;
           };
       });
            // handle setting qty available on consumable items
        angular.forEach($scope.consumableItems,function(consumableItem,key){
            if( consumableItem.qty !== consumableItem.qtyAvailable ){
                valid = false;
           };
        });
       return valid;
   };
   
   var completeWarehouseAction = function(status,comment){
        var completeWarehouseActionPromise = $q.defer();
        $scope.selectedAction.dateCompleted = new Date();
        $scope.selectedAction.success = status;
        $scope.selectedAction.comment = comment;
        HomeService.createAction($scope.selectedAction).then(function (data) {
             completeWarehouseActionPromise.resolve(true);
        });
        return completeWarehouseActionPromise.promise;
   };
   
   $scope.ok = function(){
       if( !validateWarehouseFulfilment() ){
            $scope.reasonModal={};
            $scope.reasonModal.title = "Warehouse Order cant be completed ?"
            $scope.reasonModal.reasonText = "";
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'templates/jemserinternal/modals/reasonmodal.html',
                controller: 'ReasonModalCtrl',
                size: 'md',
                scope: $scope
            });
            
            modalInstance.result.then(function (reason) {
                console.log("Reason = " + reason );
                
                completeWarehouseAction(false, reason).then(function(result){
                   $scope.handleOk();
                });
            }, function () { // do nothing 
                console.log("Dismissed");
                });
       }else{
           $scope.handleOk();
       };
   };
   
   var handleSettingQtyAvailableAndCrosshire = function(){
        // handle setting qty available , and crosshire on multiple items
        angular.forEach($scope.multipleItems,function(multipleItem,key){
           angular.forEach($scope.request.requestToJemserProductMapBeans,function(bean){

              if( bean.jemserProductId.id === multipleItem.jemserProductId.id ){
                  bean.qtyAvailable = multipleItem.qtyAvailable;
                  bean.crosshire = multipleItem.crosshire;
              } 
           });
        });
        // handle setting qty available on consumable items
        angular.forEach($scope.consumableItems,function(consumableItem,key){
           angular.forEach($scope.request.requestToJemserProductMapBeans,function(bean){

              if( bean.jemserProductId.id === consumableItem.jemserProductId.id ){
                  bean.qtyAvailable = consumableItem.qtyAvailable;
              } 
           });
        });
   };
   
   $scope.handleOk = function(){
       if($scope.okAlreadyClicked){
                console.log("prevented multiple clicks to set equipment");
                return true;
       }
       $scope.okAlreadyClicked = true;
       HomeService.getRequestById($scope.selectedAction.requestId).then(function(data){
           console.log(data.data);
           $scope.request = data.data;
           //console.log($scope.equipment);
           
           angular.forEach($scope.equipment, function(value, key){
               var oldItem = value.equipmentTypeBean;
               var newItem = value.singleItem;
               var picked = false;
               
               angular.forEach($scope.request.requestToJemserProductMapBeans, function(value, key){
                   //If we've already picked an item then no point in continuing the loop
                   console.log(oldItem);
                   console.log(newItem);
                   console.log("this the value");
                   console.log(value);
                   if (picked === false) {
                       //Making sure we don't update a product that has already been updated
                       if(value.alreadyUpdated === false || value.alreadyUpdated === null || value.alreadyUpdated === undefined){
                          
                           if(value.jemserProductId.id === oldItem.id){
                               
                               value.crosshire = oldItem.crosshire;
                               if(oldItem.crosshire !== true && newItem !== undefined){
                                   
                                    value.jemserProductId = newItem.availablePlantBean;
                               
                               }
                               picked = true;
                               value.alreadyUpdated = true; 
                               console.log("setting qtyAvailable");
                               value.qtyAvailable = 1; // its a single item
                           }
                       } 
                       
                       
                   }
               });
               
              
               
           })
           // handle setting the qtyAvailable and crosshire status for multiples , and the qtyAvailable for consumables.
           handleSettingQtyAvailableAndCrosshire();
           
           $scope.requestList = [];
           $scope.requestList.push($scope.request);
            
            $scope.requests = {};
            $scope.requests.jemserRequestBeans = $scope.requestList;
            console.log("here are the reqests");
            console.log($scope.requests);
            RequestService.createRequests($scope.requests).then(function (request) {
                console.log("synced");
                console.log(request);
                
                $scope.selectedAction.dateCompleted = new Date();
                $scope.selectedAction.success = true;
                
                if( validateWarehouseFulfilment() ){ // only create completeWarehouse action if its a fulfilled order.
                    completeWarehouseAction(true,"Fulfilled").then(function(result){
                                $scope.load();
                                $uibModalInstance.close();
                    });
                }else{ // if its unfulfiled we will have already failed the action in the ok method.
                     $scope.load();
                     $uibModalInstance.close();
                };
            });
       });
       /*$scope.selectedProducts.push($scope.selectedItem);
       console.log($scope.selectedProducts);
       $uibModalInstance.close();*/
   };
   
   
   $scope.cancel = function(){
     console.log("cancelling"); 
     $uibModalInstance.close();
   };
   
   $scope.removeWarehouseAction = function(){
        var modalOptions = {
            closeButtonText: 'Cancel',
            actionButtonText: 'Ok',
            headerText: 'Remove Warehouse Job ?',
            bodyText: 'Are you sure you want to Remove this warehouse job ?'
        };

        ConfirmModalService.showModal({}, modalOptions)
                .then(function (result) {
                    // your-custom-logic
                    if (result) {
                        completeWarehouseAction(true,"Removed").then(function(result){
                            $scope.load();
                            $uibModalInstance.close();
                        });
                    };
                   
           
        });
          
       
//          if( !validateWarehouseFulfilment() ){
//              console.log("Warehouse job is NOT valid");
//          }else{
//              console.log("Warehouse job is valid");
//          };
    };

});


diaryControllers.controller('SelectSpecificPlantCtrl', function ($log,
    /*ConfirmModalService,*/ $scope,$filter, WarehouseService,$uibModalInstance, ActionFactory,HomeService, $uibModal,$state/*,RunWarehouseReportService,ViewReportService*/) {
    
   console.log("the plant is");
   console.log($scope.availablePlants);
   
    
   $scope.setSingleItem = function(item){
       console.log(item);
       $scope.selectedItem = item;
       
   }
   
   
   
   
   
   
   $scope.ok = function(){
       
       $scope.selectedProducts.push($scope.selectedItem);
       console.log($scope.selectedProducts);
       $scope.selectedRow.chosen = true;
       $uibModalInstance.close();
   };
   
   
   $scope.cancel = function(){
     console.log("cancelling"); 
     $uibModalInstance.close();
   };
});