/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
diaryControllers.controller('myRelationshipsCtrl', function ($window,$scope, $state, MyRelationshipsService,uiGridConstants, MyEquipmentService, $uibModal) {

    $scope.showSaveButton = false;
    MyRelationshipsService.getCustomerRelationships().then(function (data) {
        $scope.customers = data.data;
        $('#navUser').text(sessionStorage.email);
        $('#navHeader').text("Jemser Management (" + sessionStorage.companyName + ')');
        $window.document.title = sessionStorage.companyName;
        console.log($scope.customers);
        angular.forEach($scope.customers, function(value, key){
                value.sourceBusinessEntity.logo = 'img/' + value.sourceBusinessEntity.logo;
            })
        $scope.customer_grid_options.data = $scope.customers;
        console.log("this is the customer grid data")
        console.log($scope.customer_grid_options.data);
        MyRelationshipsService.getSupplierRelationships().then(function (data) {
            $scope.suppliers = data.data;
            console.log($scope.suppliers);
            angular.forEach($scope.suppliers, function(value, key){
                value.targetBusinessEntity.logo = 'img/' + value.targetBusinessEntity.logo;
            })
            console.log($scope.suppliers);
            $scope.supplier_grid_options.data = $scope.suppliers;
        })

    })

    $scope.customer_grid_options = {
        enableHorizontalScrollbar: 0,
        rowHeight:50,
        enableVerticalScrollbar: 0,
        showColumnFooter: true
    };


    $scope.supplier_grid_options = {
        enableHorizontalScrollbar: 0,
        rowHeight:50,
        enableVerticalScrollbar: 0,
        showColumnFooter: true,
        gridFooterTemplate: '<a class="btn btn-primary btn-lg active btn-custom-color col-xs-24" role="button" aria-pressed="true">Add Supplier</a>' ,
        enableSorting: false,
        rowTemplate: 'templates/myRelationships/suppliersrow.html',
        onRegisterApi: function(gridApi){ $scope.gridApi = gridApi;}
    };

    $scope.customer_grid_options.columnDefs = [
        {field: 'sourceBusinessEntity.logo', name:'Logo' , cellTemplate:"<img width=\"50px\" ng-src=\"{{grid.getCellValue(row, col)}}\" lazy-src>"},
        {field: "sourceBusinessEntity.name", name: 'Company'},
        {field: "sourceBusinessEntity.address", name: 'Address'},
    ];


    $scope.supplier_grid_options.columnDefs = [
        
        {field: "seq", name: 'Priority',sort: {
              direction: uiGridConstants.ASC,
              priority: 0
            } , type:'number' },
        {field: 'targetBusinessEntity.logo', name:'Logo', cellTemplate:"<img width=\"50px\" ng-src=\"{{grid.getCellValue(row, col)}}\" lazy-src>"},
        {field: "targetBusinessEntity.name", name: 'Company'},
        {field: "targetBusinessEntity.address", name: 'Address', footerCellTemplate: "<div style='float:right;' ng-show='!grid.appScope.showSaveButton'><button style='background-color:transparent; border-color:transparent;' ng-click='grid.appScope.addSupplier()'>Add Supplier <i class='glyphicon glyphicon-plus'></i></button></div>\n\
                                                                                        <div style='float:right;' ng-show='grid.appScope.showSaveButton'><button style='background-color:transparent; border-color:transparent;' ng-click='grid.appScope.saveRelationships()'>Save Preference Order <i class='glyphicon glyphicon-plus'></i></button></div>"}
    ];


    $scope.setSupplier = function (data) {
        $scope.selectedSupplier = data;
        console.log("this is the supplier");
        console.log($scope.selectedSupplier);

    };


    $scope.increasePriority = function () {
        $scope.showSaveButton = true;
        var breakOff = false;
        if ($scope.selectedSupplier != null) {
            if ($scope.selectedSupplier.seq != 1) {
              
                //loop to get the seq above our selected and up them by one
                angular.forEach($scope.suppliers, function (value, key) {
                    if(breakOff === false){
                    if (value.seq === ($scope.selectedSupplier.seq - 1)) {
                        value.seq = value.seq + 1;
                        
                            //set break off to true so we don't re do the seq again
                            breakOff = true;
                          //now loop again after updating to down the sequence for our selected
                            angular.forEach($scope.suppliers, function (value, key) {
                            if (value.id === $scope.selectedSupplier.id) {
                                value.seq = value.seq - 1;
                                $scope.supplier_grid_options.data = $scope.suppliers; 
                                $scope.gridApi.core.refresh();
                                
                            }
                        });

                    }
                }
                });
                
                



            }
        }
    };

    $scope.decreasePriority = function () {
        var breakOff = false;
        $scope.showSaveButton = true;
        if ($scope.selectedSupplier != null) {
            if ($scope.selectedSupplier.seq != $scope.suppliers.length) {
              
                //loop to get the seq above our selected and up them by one
                angular.forEach($scope.suppliers, function (value, key) {
                    if(breakOff === false){
                    
                    if (value.seq === ($scope.selectedSupplier.seq + 1)) {
                        value.seq = value.seq - 1;
                        breakOff = true;
                          //now loop again after updating to down the sequence for our selected
                        angular.forEach($scope.suppliers, function (value, key) {
                            if (value.id === $scope.selectedSupplier.id) {
                                value.seq = value.seq + 1;
                                $scope.supplier_grid_options.data = $scope.suppliers;
                                $scope.gridApi.core.refresh();
                            }
                        });

                    }
                }
                });



            }
        }

    };
    
    
    $scope.saveRelationships = function(){
        $scope.dto = {};
        $scope.dto.businessEntityRelationshipBeans = [];
        
        angular.forEach($scope.suppliers, function (value, key) {
                            $scope.dto.businessEntityRelationshipBeans.push(value);
                            
                        });
                        
                        console.log("this si the dto");
                        console.log($scope.dto.businessEntityRelationshipBeans);
                        MyRelationshipsService.createRelationship($scope.dto).then(function(data){
                            $scope.showSaveButton = false;
                        });
    }

    $scope.isSupplierSelected = function (rowEntity) {

        if ($scope.selectedSupplier == null)
            return false;
        return  $scope.selectedSupplier.id === rowEntity.id;
    };

    
    $scope.addSupplier = function () {
        
        var modalInstance = $uibModal.open({
            animation: $scope.animationsEnabled,
            templateUrl: 'templates/myRelationships/modals/addsupplierrelationshipmodal.html',
            controller: 'AddSupplierRelationshipModalCtrl',
            size: 'md',
            scope: $scope
        });

        modalInstance.result.then(function (result) {
            console.log('result: ' + result);
            console.log(result);
            
            $scope.supplier_grid_options.data.push( result );
            $scope.gridApi.core.refresh();
                                
            // $scope.schedule = angular.fromJson(scheduleJSON);
        }, function () {
            console.info('Modal dismissed at: ' + new Date());
        });

        
    };


});

diaryControllers.controller('AddSupplierRelationshipModalCtrl', function ($scope, $state,$uibModal, $uibModalInstance, MyRelationshipsService) {
    
     MyRelationshipsService.getUnknownSupplierBusinessEntityBeans().then(function (data){
       console.log("this is the relationships");
       console.log(data);
    
       $scope.companies = data.data;
       
     });
     
     
   $scope.setSupplier = function(supplier){
       $scope.selectedCompany = supplier;
       $scope.supplier = supplier;
   };
    
    
   
   $scope.ok = function () {
       $scope.businessEntityRelationship = {};
       $scope.businessEntityRelationship.sourceBusinessEntity = {};
       $scope.businessEntityRelationship.sourceBusinessEntity.id = sessionStorage.companyId ;
       $scope.businessEntityRelationship.businessEntityCategoryId = 1001; // customer
       
       $scope.businessEntityRelationship.targetBusinessEntity = {};
       $scope.businessEntityRelationship.targetBusinessEntity.id = $scope.selectedCompany.id ;
       $scope.businessEntityRelationship.seq = $scope.supplier_grid_options.data.length + 1;
       
       
       $scope.dto = {};
       $scope.dto.businessEntityRelationshipBeans = [];
       $scope.dto.businessEntityRelationshipBeans.push( $scope.businessEntityRelationship ); 
       
       MyRelationshipsService.createRelationship($scope.dto).then(function(data){
            $uibModalInstance.close( data.data[0] );  
       });
    };

    $scope.cancel = function () {
        $uibModalInstance.dismiss('cancel');
    };
   
});