diaryServices.factory('MyRelationshipsService', function ($q, $http, Configuration, $log,$filter) {


    var getCustomerRelationships = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Customer Relationships");
        $log.info(Configuration.getConfiguration().getCustomerRelationshipsUrl+ sessionStorage.companyId);
        $http.get(Configuration.getConfiguration().getCustomerRelationshipsUrl + sessionStorage.companyId).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    
    var getAllCustomers = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Customer Relationships");
        $log.info(Configuration.getConfiguration().customerListUrl);
        $http.get(Configuration.getConfiguration().customerListUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var getSitesForCustomer = function (cust) {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Customer sites");
        $log.info(Configuration.getConfiguration().siteListUrl  + cust);
        $http.get(Configuration.getConfiguration().siteListUrl  + cust ).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var getContactsForCustomer = function (cust) {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Customer Contacts");
        $log.info(Configuration.getConfiguration().contactListUrl  + cust);
        $http.get(Configuration.getConfiguration().contactListUrl  + cust ).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var getPatientsForCustomer = function (cust) {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Customer Patients");
        $log.info(Configuration.getConfiguration().patientListUrl  + cust);
        $http.get(Configuration.getConfiguration().patientListUrl  + cust ).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    
    
    
    
    var getCustomersWithNoRate = function (productId) {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Customer with no rates");
        console.log(Configuration.getConfiguration().getCustomersWithNoRateEndpointUrl + sessionStorage.companyId + '/' + productId);
        $http.get(Configuration.getConfiguration().getCustomersWithNoRateEndpointUrl + sessionStorage.companyId + '/' + productId).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    
    var getSupplierRelationships = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Customer Relationships");

        $log.info(Configuration.getConfiguration().getSupplierRelationshipsUrl + sessionStorage.companyId);
        $http.get(Configuration.getConfiguration().getSupplierRelationshipsUrl + sessionStorage.companyId).then(function (data) {

            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    
     var createRelationship = function (suppliers) {
        console.log("creating suppliers");
        console.log(suppliers);
        var documentPostPromise = $q.defer();
        $http({method: 'POST', data: suppliers, url: Configuration.getConfiguration().saveRelationshipsUrl}).
                success(function (data, status, headers, config) {
                    //console.log("Success , synced doc to backend");

                    // only remove document from list on a status = 'SUCCESS' response from server
                    //console.log(databaseDoc);
                    //console.log("sync returnDTO");
                    console.log(data);

                    if (data.status === 'SUCCESS') {
                        //For Test only saves me continually creating documents to sync
                        console.log("Sync Successful");
                        documentPostPromise.resolve(data);

                    } else {
                        console.log("sync Failure");
                        documentPostPromise.reject(data);

                    }

                }).
                error(function (data, status, headers, config) {
                    console.log("sync Failure");
                    documentPostPromise.reject(data);

                });

        return documentPostPromise.promise;
    };
   
    var getUnknownSupplierBusinessEntityBeans = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get all Business Entity Beans ");
        
        $log.info(Configuration.getConfiguration().getUnknownSupplierBusinessEntityBeansUrl  + sessionStorage.companyId);
        
        $http.get(Configuration.getConfiguration().getUnknownSupplierBusinessEntityBeansUrl + sessionStorage.companyId ).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
   

    
    


    return{
        getCustomerRelationships: getCustomerRelationships,
        getSupplierRelationships: getSupplierRelationships,
        createRelationship: createRelationship,
        getUnknownSupplierBusinessEntityBeans: getUnknownSupplierBusinessEntityBeans,
        getCustomersWithNoRate: getCustomersWithNoRate,
        getAllCustomers: getAllCustomers,
        getSitesForCustomer: getSitesForCustomer,
        getContactsForCustomer: getContactsForCustomer,
        getPatientsForCustomer: getPatientsForCustomer,
        
    };
});
