diaryServices.factory('RequestService', function ($q, $http, Configuration, $log, $filter) {


    
    
    var getRunCategories = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Request Types");

        $http.get(Configuration.getConfiguration().runCategoryListUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var getRequestTypes = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Request Types");

        $http.get(Configuration.getConfiguration().requestTypeUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    
     var createRequests = function (requests) {
        console.log("creating request");
        console.log(requests);
        //console.log(JSON.stringify(requests, null, 4));
        var documentPostPromise = $q.defer();
        $http({method: 'POST', data: requests, url: Configuration.getConfiguration().createRequestUrl}).
                success(function (data, status, headers, config) {
                    //console.log("Success , synced doc to backend");

                    // only remove document from list on a status = 'SUCCESS' response from server
                    //console.log(databaseDoc);
                    //console.log("sync returnDTO");
                    console.log(data);

                    if (data.status === 'SUCCESS') {
                        //For Test only saves me continually creating documents to sync
                        console.log("Sync Successful");
                        documentPostPromise.resolve(data);

                    } else {
                        console.log("sync Failure");
                        documentPostPromise.reject(data);

                    }

                }).
                error(function (data, status, headers, config) {
                    console.log("sync Failure");
                    documentPostPromise.reject(data);

                });

        return documentPostPromise.promise;
    };

    return{
        getRequestTypes: getRequestTypes,
        createRequests: createRequests,
        getRunCategories: getRunCategories,
    };
});

